using System;
using System.IO;

namespace CWIDatas
{

    /// <summary>
    /// ėpIȃf[^ƂReg̃f[^B
    /// ɐpRegf[^̊{NXɂȂ܂B
    /// </summary>
    public class BaseContent : DataWithIO
    {
        #region tB[h
        protected byte mykind;

        protected string str;
        protected string str2;
        protected uint ui;
        protected int i;
        protected byte b;
        protected byte b2;

        #endregion

        #region vpeB
        /// <summary>
        /// 當̃f[^
        /// </summary>
        public string StringData
        {
            get { return str; }
            set { str = value; }
        }
        /// <summary>
        /// 當̃f[^̂Q
        /// </summary>
        public string StringData2
        {
            get { return str2; }
            set { str2 = value; }
        }
        /// <summary>
        /// 琮̃f[^i񕉁j
        /// </summary>
        public uint UInt
        {
            get { return ui; }
            set { ui = value; }
        }
        /// <summary>
        /// oCg̃f[^
        /// </summary>
        public byte Byte1
        {
            get { return b; }
        }
        /// <summary>
        /// 琮̃f[^ij
        /// </summary>
        public int Int2
        {
            get { return i; }
            set { i = value; }
        }
        /// <summary>
        /// oCg̃f[^̂Q
        /// </summary>
        public byte Byte2
        {
            get { return b2; }
        }

        public ContentType ContentKind
        {
            get { return (ContentType)mykind; }
            set { mykind = (byte)value; }
        }
        #endregion

        public BaseContent(ContentType kind) { ContentKind = kind; }

        #region [hCg
        public override void Read(BinaryReader r)
        {
            switch (ContentKind)
            {
                // ^
                case ContentType.LinkStart:  // X^[gNReg (terminal)
                case ContentType.PlayBgm:  // aflReg (standard)
                case ContentType.PlaySound:  // ʉReg (standard)
                case ContentType.BranchFlag:  // tOReg (data)
                case ContentType.BranchMultiStep:  // Xebv򕪊Reg (data)
                case ContentType.SetStepUp:  // XebvReg (data)
                case ContentType.SetStepDown:  // XebvReg (data)
                case ContentType.ReverseFlag:  // tO]Reg (data)
                case ContentType.CallStart:  // X^[gR[Reg (standard)
                case ContentType.BranchStamp:  // I󕪊Reg (branch)
                case ContentType.GetStamp:  // ItReg (get)
                case ContentType.LostStamp:  // I폜Reg (lost)
                case ContentType.BranchGossip:  // SVbvReg (branch)
                case ContentType.GetGossip:  // SVbvǉReg (get)
                case ContentType.LostGossip:  // SVbv폜Reg (lost)
                case ContentType.CheckFlag:  // tOReg (data)
                    str = r.ReadString();
                    break;

                // ^
                case ContentType.ViewDelete:    // wi폜Reg (standard) 
                    str = ((SjisCBinaryReader)r).ReadSmallString();
                    break;

                // {Sa^
                case ContentType.BranchStep:  // Xebv㉺Reg (data)
                case ContentType.SetStep:  // XebvύXReg (data)
                    str = r.ReadString();
                    ui = r.ReadUInt32();
                    break;

                // {Sa{Pa^
                case ContentType.GetCoupon:  // N[|擾Reg (get)
                case ContentType.LostCoupon:  // N[|rReg (lost)
                case ContentType.BranchCoupon:  // N[|Reg (branch)
                case ContentType.CheckStep:  // XebvReg (data)
                    str = r.ReadString();
                    i = r.ReadInt32();
                    b = r.ReadByte();
                    break;

                // {Pa^
                case ContentType.SetFlag:  // tOύXReg (data)
                    str = r.ReadString();
                    b = r.ReadByte();
                    break;

                // {^
                case ContentType.SubstituteStep:  // XebvReg (data)
                case ContentType.SubstituteFlag:  // tOReg (data)
                case ContentType.BranchStepCmp:  // XebvrReg (data)
                case ContentType.BranchFlagCmp:  // tOrReg (data)
                    str = r.ReadString();
                    str2 = r.ReadString();
                    break;

                // Sa^
                case ContentType.Wait:  // 󔒎ԃReg (standard)
                case ContentType.Battle:  // ogReg (terminal)
                case ContentType.ChangeArea:  // GAړReg (terminal)
                case ContentType.LinkPackage:  // pbP[WNReg (terminal)
                case ContentType.CallPackage:  // pbP[WR[Reg (standard)
                case ContentType.GetCast:  // LXgReg (get)
                case ContentType.LostCast:  // LXgEReg (lost)
                case ContentType.BranchCast:  // LXgReg (branch)
                case ContentType.GetInfo:  // Reg (get)
                case ContentType.LostInfo:  // rReg (lost)
                case ContentType.BranchInfo:  // 񕪊Reg (branch)
                case ContentType.GetMoney:  // Reg (get)
                case ContentType.LostMoney:  // Reg (lost)
                case ContentType.BranchMoney:  // Reg (branch)
                case ContentType.BranchRandom:  // _Reg (utility)
                case ContentType.BranchPartyNumber:  // lReg (utility)
                    ui = r.ReadUInt32();
                    break;

                // Sa{Sa{Pa^
                case ContentType.GetItem:     // ACeReg (get)
                case ContentType.LostItem:    // ACerReg (lost)
                case ContentType.BranchItem:  // ACeReg (branch)
                case ContentType.GetSkill:  // Z\Reg (get)
                case ContentType.LostSkill:  // Z\rReg (lost)
                case ContentType.BranchSkill:  // Z\Reg (branch)
                case ContentType.GetBeast:  // bReg (get)
                case ContentType.LostBeast:  // brReg (lost)
                case ContentType.BranchBeast:  // bReg (branch)
                    ui = r.ReadUInt32();
                    i = r.ReadInt32();
                    b = r.ReadByte();
                    break;

                // Pa^
                case ContentType.End:  // IReg (terminal)
                    b = r.ReadByte();
                    break;

                // Pa{Pa^
                case ContentType.MemberSelect:  // oIReg (utility)
                case ContentType.BranchStatus:  // ԔReg (utility)
                    b = r.ReadByte();
                    b2 = r.ReadByte();
                    break;

                // Pa{Sa^
                case ContentType.BranchLevel:  // xReg (utility)
                case ContentType.BranchRound:  // EhReg (utility)
                    b = r.ReadByte();
                    ui = r.ReadUInt32();
                    break;

                // Pa{Pa{^
                case ContentType.BranchKeyCode:  // L[R[hReg (branch)
                    b = r.ReadByte();
                    b2 = r.ReadByte();
                    str = r.ReadString();
                    break;

                // f[^Ȃ^
                case ContentType.Start:  // X^[gReg (terminal)
                case ContentType.GameOver:  // Q[I[o[Reg (terminal)
                case ContentType.ElapseTime:  // ^[o߃Reg (standard)
                case ContentType.ShowParty:  // p[eB[\Reg (visual)
                case ContentType.HideParty:  // p[eB[BReg (visual)
                case ContentType.EffectBreak:  // ʒfReg (terminal)
                case ContentType.BranchArea:  // GAReg (utility)
                case ContentType.BranchBattle:  // ogReg (utility)
                case ContentType.BranchIsBattle:  // og蕪Reg (utility)
                case ContentType.ReDisplay:  // ʍč\zReg (visual)
                    break;

                // ̑^
                case ContentType.AbilityCheck:  //\͔Reg (utility)
                case ContentType.ViewChange:  // wiύXReg (standard)
                case ContentType.Effect:  // ʃReg (standard)
                case ContentType.Serif:  // ZtReg (standard)
                case ContentType.Message:  // bZ[WReg (standard)
                case ContentType.RandomSelect:  // _IReg (utility)
                case ContentType.ViewPosSize:  // wiʒuETCYύXReg (standard) 
                case ContentType.ViewReplace:  // wiuReg (standard) 
                    //͋N肦Ȃ͂B
                    //ʃNXŃI[o[ChĂ
                    break;
            }
        }
        public override void Write(BinaryWriter w)
        {
            switch (ContentKind)
            {
                // ^
                case ContentType.LinkStart:  // X^[gNReg (terminal)
                case ContentType.PlayBgm:  // aflReg (standard)
                case ContentType.PlaySound:  // ʉReg (standard)
                case ContentType.BranchFlag:  // tOReg (data)
                case ContentType.BranchMultiStep:  // Xebv򕪊Reg (data)
                case ContentType.SetStepUp:  // XebvReg (data)
                case ContentType.SetStepDown:  // XebvReg (data)
                case ContentType.ReverseFlag:  // tO]Reg (data)
                case ContentType.CallStart:  // X^[gR[Reg (standard)
                case ContentType.BranchStamp:  // I󕪊Reg (branch)
                case ContentType.GetStamp:  // ItReg (get)
                case ContentType.LostStamp:  // I폜Reg (lost)
                case ContentType.BranchGossip:  // SVbvReg (branch)
                case ContentType.GetGossip:  // SVbvǉReg (get)
                case ContentType.LostGossip:  // SVbv폜Reg (lost)
                case ContentType.CheckFlag:  // tOReg (data)
                    w.Write(str);
                    break;

                // ^
                case ContentType.ViewDelete:    // wi폜Reg (standard) 
                    ((SjisCBinaryWriter)w).WriteSmallString(str);
                    break;

                // {Sa^
                case ContentType.BranchStep:  // Xebv㉺Reg (data)
                case ContentType.SetStep:  // XebvύXReg (data)
                    w.Write(str);
                    w.Write(ui);
                    break;

                // {Sa{Pa^
                case ContentType.GetCoupon:  // N[|擾Reg (get)
                case ContentType.LostCoupon:  // N[|rReg (lost)
                case ContentType.BranchCoupon:  // N[|Reg (branch)
                case ContentType.CheckStep:  // XebvReg (data)
                    w.Write(str);
                    w.Write(i);
                    w.Write(b);
                    break;

                // {Pa^
                case ContentType.SetFlag:  // tOύXReg (data)
                    w.Write(str);
                    w.Write(b);
                    break;

                // {^
                case ContentType.SubstituteStep:  // XebvReg (data)
                case ContentType.SubstituteFlag:  // tOReg (data)
                case ContentType.BranchStepCmp:  // XebvrReg (data)
                case ContentType.BranchFlagCmp:  // tOrReg (data)
                    w.Write(str);
                    w.Write(str2);
                    break;

                // Sa^
                case ContentType.Wait:  // 󔒎ԃReg (standard)
                case ContentType.Battle:  // ogReg (terminal)
                case ContentType.ChangeArea:  // GAړReg (terminal)
                case ContentType.LinkPackage:  // pbP[WNReg (terminal)
                case ContentType.CallPackage:  // pbP[WR[Reg (standard)
                case ContentType.GetCast:  // LXgReg (get)
                case ContentType.LostCast:  // LXgEReg (lost)
                case ContentType.BranchCast:  // LXgReg (branch)
                case ContentType.GetInfo:  // Reg (get)
                case ContentType.LostInfo:  // rReg (lost)
                case ContentType.BranchInfo:  // 񕪊Reg (branch)
                case ContentType.GetMoney:  // Reg (get)
                case ContentType.LostMoney:  // Reg (lost)
                case ContentType.BranchMoney:  // Reg (branch)
                case ContentType.BranchRandom:  // _Reg (utility)
                case ContentType.BranchPartyNumber:  // lReg (utility)
                    w.Write(ui);
                    break;

                // Sa{Sa{Pa^
                case ContentType.GetItem:     // ACeReg (get)
                case ContentType.LostItem:    // ACerReg (lost)
                case ContentType.BranchItem:  // ACeReg (branch)
                case ContentType.GetSkill:  // Z\Reg (get)
                case ContentType.LostSkill:  // Z\rReg (lost)
                case ContentType.BranchSkill:  // Z\Reg (branch)
                case ContentType.GetBeast:  // bReg (get)
                case ContentType.LostBeast:  // brReg (lost)
                case ContentType.BranchBeast:  // bReg (branch)
                    w.Write(ui);
                    w.Write(i);
                    w.Write(b);
                    break;

                // Pa^
                case ContentType.End:  // IReg (terminal)
                    w.Write(b);
                    break;

                // Pa{Pa^
                case ContentType.MemberSelect:  // oIReg (utility)
                case ContentType.BranchStatus:  // ԔReg (utility)
                    w.Write(b);
                    w.Write(b2);
                    break;

                // Pa{Sa^
                case ContentType.BranchLevel:  // xReg (utility)
                case ContentType.BranchRound:  // EhReg (utility)
                    w.Write(b);
                    w.Write(ui);
                    break;

                // Pa{Pa{^
                case ContentType.BranchKeyCode:  // L[R[hReg (branch)
                    w.Write(b);
                    w.Write(b2);
                    w.Write(str);
                    break;

                // f[^Ȃ^
                case ContentType.Start:  // X^[gReg (terminal)
                case ContentType.GameOver:  // Q[I[o[Reg (terminal)
                case ContentType.ElapseTime:  // ^[o߃Reg (standard)
                case ContentType.ShowParty:  // p[eB[\Reg (visual)
                case ContentType.HideParty:  // p[eB[BReg (visual)
                case ContentType.EffectBreak:  // ʒfReg (terminal)
                case ContentType.BranchArea:  // GAReg (utility)
                case ContentType.BranchBattle:  // ogReg (utility)
                case ContentType.BranchIsBattle:  // og蕪Reg (utility)
                case ContentType.ReDisplay:  // ʍč\zReg (visual)
                    break;

                // ̑^
                case ContentType.AbilityCheck:  //\͔Reg (utility)
                case ContentType.ViewChange:  // wiύXReg (standard)
                case ContentType.Effect:  // ʃReg (standard)
                case ContentType.Serif:  // ZtReg (standard)
                case ContentType.Message:  // bZ[WReg (standard)
                case ContentType.RandomSelect:  // _IReg (utility)
                case ContentType.ViewPosSize:  // wiʒuETCYύXReg (standard) 
                case ContentType.ViewReplace:  // wiuReg (standard) 
                
                //͋N肦Ȃ͂B
                    //ʃNXŃI[o[ChĂ
                    break;
            }
        }
        #endregion

    }//class BaseContent
}
