using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace CWIDatas
{
    /// <summary>
    /// ʃReg̃f[^
    /// </summary>
    public class EffectContent : BaseContent
    {
        #region tB[h
        uint version = 0;
        #endregion

        #region vpeB
        /// <summary>
        /// ʃx
        /// </summary>
        public int Level
        {
            get { return i; }
            set
            {
                if (value < CWData.ContentMinLevel) i = CWData.ContentMinLevel;
                else if (value > CWData.ContentMaxLevel) i = CWData.ContentMaxLevel;
                else i = value;
            }
        }
        byte attribute;
        /// <summary>
        /// ʑFex)@I
        /// </summary>
        public ʑ EffectAttribute
        {
            get { return (ʑ)attribute; }
            set { attribute = (byte)value; }
        }
        byte resist;
        /// <summary>
        /// RFex)𑮐
        /// </summary>
        public R ResistAttribute
        {
            get { return (R)resist; }
            set { resist = (byte)value; }
        }
        /// <summary>
        /// ΏہFex)p[eBS
        /// </summary>
        public Ώ Target
        {
            get { return (Ώ)b2; }
            set { b2 = (byte)value; }
        }
        int success;
        /// <summary>
        /// C
        /// </summary>
        public int SuccessRate
        {
            get { return success; }
            set
            {
                if (value < CWData.MinSuccessRate) success = CWData.MinSuccessRate;
                else if (value > CWData.MaxSuccessRate) success = CWData.MaxSuccessRate;
                success = value;
            }
        }
        /// <summary>
        /// ʉt@C
        /// </summary>
        public string SoundFile
        {
            get { return str; }
            set { str = value; }
        }
        /// <summary>
        /// J[hoʁFex)]
        /// </summary>
        public o VisualEffect
        {
            get { return (o)b; }
            set { b = (byte)value; }
        }
        List<EffectData> effectList;
        /// <summary>
        /// 
        /// </summary>
        public List<EffectData> Effects
        {
            get
            {
                if (effectList == null)
                    effectList = new List<EffectData>();
                return effectList;
            }
        }
        #endregion

        public EffectContent() : base(ContentType.Effect) { version = CWData.DataVersion4; }

        public EffectContent(uint ver) : base(ContentType.Effect) { version = ver; }

        #region [hCg
        public override void Read(BinaryReader r)
        {
            // ʃx
            Level = r.ReadInt32();

            // ΏہFex)p[eBS
            b2 = r.ReadByte();
            // ʑFex)
            attribute = r.ReadByte();
            // RFex)𑮐
            resist = r.ReadByte();
            // C
            SuccessRate = r.ReadInt32();

            // ʉt@C
            SoundFile = r.ReadString();

            // J[hoʁFex)]
            b = r.ReadByte();

            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EffectData d = new EffectData(version);
                d.Read(r);
                Effects.Add(d);
            }
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(Level);
            w.Write(b2);
            w.Write(attribute);
            w.Write(resist);
            w.Write(SuccessRate);

            w.Write(SoundFile);

            w.Write(b);
            w.Write(Effects.Count);
            foreach (EffectData d in Effects)
                d.Write(w);
        }
        #endregion

    }// class EffectContent
}
