/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace CWIDatas
{

    /// <summary>
    /// wiύXReg̃f[^
    /// </summary>
    public class ViewChangeContent : BaseContent
    {
        #region tB[h
        List<CellData> cellList;
        #endregion

        #region vpeB
        public List<CellData> Cells
        {
            get
            {
                if (cellList == null)
                    cellList = new List<CellData>();
                return cellList;
            }
        }
        #endregion

        public ViewChangeContent() : base(ContentType.ViewChange) { }

        #region [hCg
        public override void Read(BinaryReader r)
        {
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                CellData cell = new CellData();
                cell.Read(r);
                Cells.Add(cell);
            }
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(Cells.Count);
            foreach (CellData cell in Cells)
                cell.Write(w);
        }
        #endregion
    }
}
