using System;
using System.IO;
using System.Drawing;

namespace CWIDatas
{
    /// <summary>
    /// f[^Ƀt@C̃[hCg\bh{ۃNXB
    /// wǂ̃f[^\NXɌpB
    /// </summary>
    public abstract class DataWithIO
    {
        public abstract void Read(BinaryReader r);
        public abstract void Write(BinaryWriter w);
        /// <summary>
        /// t@CI[vÃf[^ǂݍ݂܂B
        /// </summary>
        /// <param name="file">ǂݍރt@C̖OitpXj</param>
        public virtual void Read(string file)
        {
            using (BinaryReader r = new SjisCBinaryReader(File.OpenRead(file)))
            {
                Read(r);
            }
        }

        /// <summary>
        /// oCgz̃Xg[f[^ǂݍ݂܂B
        /// </summary>
        /// <param name="allBytes">oCgz</param>
        public virtual void Read(byte[] allBytes)
        {
            using (BinaryReader r = new SjisCBinaryReader(new MemoryStream(allBytes)))
            {
                Read(r);
            }
        }

        /// <summary>
        /// t@CI[vÃf[^݂܂B
        /// </summary>
        /// <param name="file">ރt@C̖OitpXj</param>
        public virtual void Write(string file)
        {
            using (BinaryWriter w = new SjisCBinaryWriter(File.OpenWrite(file)))
            {
                Write(w);
            }
        }

    }//class DataWithIO
}
