/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using System.IO;
using System.Drawing;

namespace CWIDatas
{
    public class ImageData : DataWithIO
    {
        private MemoryStream mstream;
        private int size;

        private Bitmap imageNotTransparent;
        private Bitmap image;


        /// <summary>
        /// 摜f[^A͂܂ĂȂ
        /// </summary>
        public bool empty
        {
            get { return this.bitmap == null || 
                         this.bitmap.Size.Width * this.bitmap.Size.Height == 0; }
        }

        public Bitmap baseBitmap
        {
            get { return imageNotTransparent; }
            set 
            {
                imageNotTransparent = value;
                SetupSize();
                if (0 != size)
                {
                    image = (Bitmap)imageNotTransparent.Clone();
                    image.MakeTransparent(image.GetPixel(0, 0));
                }
                else
                {
                    image = null;
                }
            }
        }

        public Bitmap bitmap
        {
            get { return image; }
        }

        private bool noSave = false;
        /// <summary>
        /// 摜Ȃ̂Ƃ
        /// </summary>
        public bool NoSave
        {
            get { return noSave; }
            set { noSave = value; }
        }

        private void SetupSize()
        {
            if (imageNotTransparent == null)
            {
                // 摜Ȃꍇ肻
                size = 0;
                return;
            }

            string filename = "temp_"
             + DateTime.Now.ToString("yyyyMMdd_HHmmss_fff")
             + ".bmp";
            imageNotTransparent.Save(filename, System.Drawing.Imaging.ImageFormat.Bmp);
            FileInfo info = new FileInfo(filename);
            if (info.Length > int.MaxValue)
                throw new Exception();
            size = (int)info.Length;
            info.Delete();
            info = null;
        }

        public ImageData(Bitmap bmp)
        {
            imageNotTransparent = bmp;
            image = (Bitmap)imageNotTransparent.Clone();
            image.MakeTransparent(image.GetPixel(0, 0));
        }

        public ImageData()
        {
        }

        public override void Read(BinaryReader r)
        {
            size = r.ReadInt32();
            if (0 == size)
                return;
            byte[] buf = r.ReadBytes(size);
            mstream = new MemoryStream(size);
            mstream.Write(buf, 0, size);
            imageNotTransparent = new Bitmap(mstream);

            image = (Bitmap)imageNotTransparent.Clone();
            image.MakeTransparent(image.GetPixel(0, 0));
        }

        public override void Write(BinaryWriter w)
        {
            if (noSave)
            {
                w.Write(0);
                return;
            }
            //ǂݍ񂾉摜Əމ摜ɈႤ
            // ŎTCY߂
            SetupSize();

            w.Write(size);
            if (0 == size)
            {
                return;
            }

            string filename = "temp_"
             + DateTime.Now.ToString("yyyyMMdd_HHmmss_fff")
             + ".bmp";
            imageNotTransparent.Save(filename, System.Drawing.Imaging.ImageFormat.Bmp);
            
            byte[] buf = File.ReadAllBytes(filename);
            w.Write(buf, 0, size);
            File.Delete(filename);
            buf = null;
        }
    }
}
