/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
using System;
using System.IO;
using System.Collections.Generic;


namespace CWIDatas
{
    /// <summary>
    /// ogt@CɂGl~[J[h̃f[^
    /// </summary>
    public class EnemyData : DataWithIO
    {
        #region tB[h
        uint castNumber;
        List<EventData> eventList;
        string flag;
        uint scale;
        int left;
        int top;
        byte escape;
        #endregion

        #region vpeB
        /// <summary>
        /// LXgiGl~[j̃J[hԍ
        /// </summary>
        public uint CastNumber
        {
            get { return castNumber; }
            set { castNumber = value; }
        }
        /// <summary>
        /// Gl~[CxgXg
        /// </summary>
        public List<EventData> Events
        {
            get
            {
                if (eventList == null)
                    eventList = new List<EventData>();
                return eventList;
            }
        }
        /// <summary>
        /// QƃtO
        /// </summary>
        /// <param name="w"></param>
        public string FlagName
        {
            get { return flag; }
            set { flag = value; }
        }
        /// <summary>
        /// J[hTCYBXP[BP
        /// </summary>
        public uint Scale
        {
            get { return scale; }
            set
            {
                if (value < CWData.CardScaleMin)
                    scale = CWData.CardScaleMin;
                else if (value > CWData.CardScaleMax)
                    scale = CWData.CardScaleMax;
                else
                    scale = value;
            }
        }
        public int Left
        {
            get { return left; }
            set { left = value; }
        }
        public int Top
        {
            get { return top; }
            set { top = value; }
        }
        /// <summary>
        /// ̉\
        /// </summary>
        public bool RunAway
        {
            get { return !(escape == 0); }
            set { escape = (byte)(value ? 1 : 0); }
        }
        #endregion

        #region [hCg
        public override void Read(BinaryReader r)
        {
            castNumber = r.ReadUInt32();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EventData ev = new EventData();
                ev.Read(r);
                Events.Add(ev);
            }
            flag = r.ReadString();
            scale = r.ReadUInt32();
            left = r.ReadInt32();
            top = r.ReadInt32();
            escape = r.ReadByte();
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(castNumber);
            w.Write(Events.Count);
            foreach (EventData ev in Events)
                ev.Write(w);
            w.Write(flag);
            w.Write(scale);
            w.Write(left);
            w.Write(top);
            w.Write(escape);
        }
        #endregion
    }//class EnemyData
}
