/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace CWIDatas
{
    public class EventData : DataWithIO
    {
        #region tB[h
        List<ContentData> startList;
        List<int> systemFire;
        StringCollection keycodeList;
        bool fire;
        #endregion

        #region vpeB
        public List<ContentData> Starts
        {
            get
            {
                if (startList == null)
                    startList = new List<ContentData>();
                return startList;
            }
        }
        public List<int> SystemFireNumbers
        {
            get
            {
                if (systemFire == null)
                    systemFire = new List<int>();
                return systemFire;
            }
        }
        public StringCollection KeyCodes
        {
            get
            {
                if (keycodeList == null)
                    keycodeList = new StringCollection();
                return keycodeList;
            }
        }
        #endregion

        public EventData() : this(true) { ;}
        /// <summary>
        /// CxgIuWFNg̃RXgN^
        /// </summary>
        /// <param name="isfire">ΏGAŐ^ApbP[WAgpCxg͋U</param>
        public EventData(bool isfire)
        {
            fire = isfire;
        }

        #region [hCg
        public override void Read(BinaryReader r)
        {
            uint count = r.ReadUInt32();
            ContentData con;
            for (; count > 0; count--)
            {
                con = new ContentData();
                con.Read(r);
                Starts.Add(con);
            }
            if (fire)
            {
                count = r.ReadUInt32();
                for (; count > 0; count--)
                {
                    SystemFireNumbers.Add(r.ReadInt32());
                }
                keycodeList = ((SjisCBinaryReader)r).ReadStringCollection();
            }
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(Starts.Count);
            foreach (ContentData c in Starts)
                c.Write(w);
            if (fire)
            {
                w.Write(SystemFireNumbers.Count);
                foreach (int i in SystemFireNumbers)
                    w.Write(i);
                ((SjisCBinaryWriter)w).Write(KeyCodes);
            }
        }
        #endregion

    }
}
