/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
/**
 * Summaryt@C̃f[^
 */

using System;
using System.Collections.Specialized;
using System.Collections.Generic;

namespace CWIDatas
{
    /// <summary>
    /// Description of SummaryData
    /// </summary>
    public class SummaryData : DataWithIO
    {
        #region tB[h
        ImageData image;
        string scenario;
        string expression;
        string author;
        StringCollection needCoupon;
        uint needCouponCount;
        uint areaANDversion;
        List<StepIndexData> stepList;
        List<FlagIndexData> flagList;
        int nazo0;
        uint levelLow;
        uint levelHigh;
        #endregion

        #region vpeB
        public ImageData Image
        {
            get { return image; }
        }
        public string ScenarioName
        {
            get { return scenario; }
            set { scenario = value; }
        }
        public string ScenarioExpression
        {
            get { return expression; }
            set { expression = value; }
        }
        public string Author
        {
            get { return author; }
            set { author = value; }
        }
        public StringCollection NeedCoupons
        {
            get
            {
                if (needCoupon == null)
                    needCoupon = new StringCollection();
                return needCoupon;
            }
        }
        public uint NeedCouponCount
        {
            get { return needCouponCount; }
            set { needCouponCount = value; }
        }

        public uint Version
        {
            get { return areaANDversion / CWData.VersionOffset; }
            set { areaANDversion = AreaNumber + value * CWData.VersionOffset; }
        }
        /// <summary>
        /// JnGAԍ
        /// </summary>
        public uint AreaNumber
        {
            get { return areaANDversion % CWData.VersionOffset; }
            set { areaANDversion = value + Version * CWData.VersionOffset; }
        }
        public List<StepIndexData> Steps
        {
            get
            {
                if (stepList == null)
                    stepList = new List<StepIndexData>();
                return stepList;
            }
        }
        public List<FlagIndexData> Flags
        {
            get
            {
                if (flagList == null)
                    flagList = new List<FlagIndexData>();
                return flagList;
            }
        }
        public uint LevelLow
        {
            get { return levelLow; }
            set { levelLow = value; }
        }
        public uint LevelHigh
        {
            get { return levelHigh; }
            set { levelHigh = value; }
        }
        #endregion

        public SummaryData() { image = new ImageData(); }

        #region [hCg
        public override void Read(System.IO.BinaryReader r)
        {
            image.Read(r);
            scenario = r.ReadString();
            expression = ((SjisCBinaryReader)r).ReadStringCRLF();
            author = r.ReadString();
            needCoupon = ((SjisCBinaryReader)r).ReadStringCollection();
            needCouponCount = r.ReadUInt32();
            areaANDversion = r.ReadUInt32();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                StepIndexData step = new StepIndexData();
                step.Read(r);
                Steps.Add(step);
            }
            count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                FlagIndexData flag = new FlagIndexData();
                flag.Read(r);
                Flags.Add(flag);
            }

            nazo0 = r.ReadInt32();

            if (r.PeekChar() != -1)
            {
                levelLow = r.ReadUInt32();
                levelHigh = r.ReadUInt32();
            }
  
        }
        public override void Write(System.IO.BinaryWriter w)
        {
            image.Write(w);
            w.Write(scenario);
            ((SjisCBinaryWriter)w).WriteCRLF(expression);
            w.Write(author);
            ((SjisCBinaryWriter)w).Write(needCoupon);
            w.Write(needCouponCount);
            w.Write(areaANDversion);
            w.Write(Steps.Count);
            foreach (StepIndexData d in Steps)
                d.Write(w);
            w.Write(Flags.Count);
            foreach (FlagIndexData d in Flags)
                d.Write(w);
            w.Write(nazo0);
            w.Write(levelLow);
            w.Write(levelHigh);
        }
        #endregion
    }
}
