using System;
using System.Windows.Forms;

namespace CWI.Button
{
    public class PanelButtonRepeat : PanelButtonEx
    {
        protected Timer repeatTimer;
        protected int interval = 500;
        protected bool noTimerExecution = true;
        protected EventHandler eTic;
        /// <summary>
        /// tB[hZbgp\bhBݒutH[̃RXgN^ŌĂԂƁB
        /// </summary>
        /// <param name="exec">{^s̍ۂɃR[fQ[g</param>
        /// <param name="draw">{^ɒǉ̉摜߂̃fQ[g</param>
        /// <param name="timer">̃{^Ɏg킵Ă炦^C}[BLȂĂ悢</param>
        public void SetUp(VoidDelegate exec, DrawDelegateEx drawex, Timer timer)
        {
            base.SetUp(exec, drawex);
            repeatTimer = timer;
            repeatTimer.Interval = interval;
            eTic = new EventHandler(timerTic);
        }

        //Ń^C}[It
        public override void SetBtnEnable(bool value)
        {
            if (!value)
            {
                repeatTimer.Enabled = false;
                repeatTimer.Tick -= eTic;
                pushing = false;
            }
            base.SetBtnEnable(value);
        }
        //^C}[ƂɃNbNs
        protected void timerTic(object sender, EventArgs e)
        {
            if (!btnEnable)
                return;
            //repeatTimer.Enabled = false;
            noTimerExecution = false;
            ButtonExecute();
            //repeatTimer.Enabled = true;ƃ^C}[ȂȂ
        }

        //^C}[Lǉ
        protected override void PanelButton_MouseDown(object sender, MouseEventArgs e)
        {
            if (!btnEnable)
                return;
            pushing = true;
            noTimerExecution = true;
            repeatTimer.Tick += eTic;
            repeatTimer.Enabled = true;
            this.Invalidate();
        }
        //^C}[ǉ
        protected override void PanelButton_MouseUp(object sender, MouseEventArgs e)
        {
            if (!btnEnable)
                return;
            repeatTimer.Enabled = false;
            repeatTimer.Tick -= eTic;
            //Ƀ^C}[ɂsĂExecuteȂ
            if (noTimerExecution)
                base.PanelButton_MouseUp(sender, e);
            else
            {
                pushing = false;
                this.Invalidate();
            }
        }
        //^C}[Lǉ
        protected override void PanelButton_MouseMove(object sender, MouseEventArgs e)
        {
            if (!btnEnable)
                return;
            //}EXLv`[ԂŃ}EXɂ牟ԂɕύX
            if (this.Capture)
            {
                if (pushing &&
                    (e.X < 0 || e.X > this.Width || e.Y < 0 || e.Y > this.Height))
                {
                    pushing = false;
                    repeatTimer.Enabled = false;
                    repeatTimer.Tick -= eTic;
                    noTimerExecution = true;
                    this.Invalidate();
                }
                else if (!pushing &&
                    !(e.X < 0 || e.X > this.Width || e.Y < 0 || e.Y > this.Height))
                {
                    pushing = true;
                    repeatTimer.Enabled = true;
                    repeatTimer.Tick += eTic;
                    this.Invalidate();
                }
            }
        }

    }//class
}//namespace
