using System;
using System.Drawing;
using System.Collections.Generic;
using CWIDatas;

namespace CWI.Card
{
    public class BattleHandCard : HandCard
    {
        /// <summary>
        /// ʔ͈͒P̂̏ꍇ̖ڕWLN^[
        /// </summary>
        public CharacterCard battleTarget;

        public BattleHandCard(WidCard refCard)
            : base(D.XL, refCard)
        {
            battleTarget = null;
        }

        public void UpdateImage(int green)
        {
            //tH[JXŔ]ȂfR[VG
            using (Graphics g = Graphics.FromImage(cardDecoImage))
            {
                //Ḱ
                if (green >= 0)
                {
                    if (green > HandCard.colorLevelGreen)
                        green = HandCard.colorLevelGreen;
                    g.DrawImage(IconGreen_Bmp[green], IconGreenX, IconGreenY);
                }
                //z[h
                if (widData.HoldCard)
                    g.DrawImage(Deco_Hold, 0, 0);
                //yieB
                if (Util2.IsPenaltyCard(widData))
                    g.DrawImage(Deco_Penalty, 0, 0);
                //
                if (widData.WidID == WidIDtype.ACe)
                {
                    Brush col = null;
                    if (Util2.IsRecycleCard(widData))
                    {//TCNJ[hib͈Ⴄj
                        col = new SolidBrush(Color.Yellow);
                    }
                    else if (widData.ItemRemainUseCount > 0)
                    {//ʏJ[hŉ񐔂
                        col = PartyMaker.WhiteBrush;
                    }
                    if (col != null)
                    {
                        Font CountFont = new Font("lr o", 12, FontStyle.Bold);

                        StringFormat format = new StringFormat();
                        format.Alignment = StringAlignment.Center;
                        string s = widData.ItemRemainUseCount.ToString();
                        int x = 2, y = 90, w = 27, h = CountFont.Height;
                        Rectangle rec;
                        rec = new Rectangle(x - 1, y - 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x - 1, y, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x - 1, y + 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x, y - 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x, y + 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x + 1, y - 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x + 1, y, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x + 1, y + 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x, y, w, h);
                        g.DrawString(s, CountFont, col, rec, format);
                    }
                }
            }
        }

    }//class
}
