using System;
using System.Drawing;
using CWIDatas;

namespace CWI.Card
{
    class BeastHandCard : HandCard
    {
        public BeastHandCard(WidCard beast)
            : base(D.Lb, beast) { }

        /// <summary>
        /// tH[JXŔ]ȂfR[V̉摜쐬B
        /// 摜CardDecoImage\bhŎ擾
        /// </summary>
        /// <param name="green">K̃x</param>
        public virtual void UpdateImage(int green)
        {
            //tH[JXŔ]ȂfR[VG
            using (Graphics g = Graphics.FromImage(cardDecoImage))
            {
                //Ḱ
                if (green >= 0)
                {
                    if (green > HandCard.colorLevelGreen)
                        green = HandCard.colorLevelGreen;
                    g.DrawImage(IconGreen_Bmp[green], IconGreenX, IconGreenY);
                }
                //yieB
                if (Util2.IsPenaltyCard(widData))
                    g.DrawImage(Deco_Penalty, 0, 0);
                //
                Brush col = null;
                if (!widData.HutaiBeast && widData.ItemRemainUseCount > 0)
                {//tє\͂łȂA񐔂
                    col = PartyMaker.WhiteBrush;
                    Font CountFont = new Font("lr o", 12, FontStyle.Bold);

                    StringFormat format = new StringFormat();
                    format.Alignment = StringAlignment.Center;
                    string s = widData.ItemRemainUseCount.ToString();
                    int x = 2, y = 90, w = 27, h = CountFont.Height;
                    Rectangle rec;
                    rec = new Rectangle(x - 1, y - 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x - 1, y, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x - 1, y + 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x, y - 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x, y + 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x + 1, y - 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x + 1, y, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x + 1, y + 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x, y, w, h);
                    g.DrawString(s, CountFont, col, rec, format);
                }
            }
        }
    }//class
}
