using System;
using System.Drawing;
using System.Collections.Generic;
using CWIDatas;

namespace CWI.Card
{
    /// <summary>
    /// 퓬sLN^[J[h̃NX
    /// </summary>
    public class CharacterCard : CharacterSizeCard
    {
        #region 萔
        protected static readonly int HPBarImageWidth = 79;
        protected static readonly int HPBarImageHeight = 13;
        protected static readonly Font CharacterLevelFont = new Font("lr o", 24, FontStyle.Bold | FontStyle.Italic);
        protected static readonly Brush CharacterLevelBrush = new SolidBrush(Color.FromArgb(96, 96, 96));
        protected static readonly Rectangle CharacterLevelRect = new Rectangle(52, 0, 40, 28);
        protected static readonly Font BeastMarkFont = new Font("Terminal", 8);
        #endregion

        #region \[X摜`
        protected static Bitmap CastBackgroundImage_N;
        protected static Bitmap CastBackgroundImage_o[X;
        protected static Bitmap CastBackgroundImage_ӎs;
        protected static Bitmap CastBackgroundImage_Ή;
        protected static Bitmap CastBackgroundImage_;
        protected static Bitmap CastBackgroundImage_;
        protected static Bitmap CastBackgroundImage_;
        protected static Bitmap CastBackgroundImage_;
        protected static Bitmap CastBackgroundImage_d;
        protected static Bitmap CastImage_HPBlock;
        protected static Bitmap CastImage_HPBar;
        protected static Bitmap CastIcon_;
        protected static Bitmap CastIcon_;
        protected static Bitmap CastIcon_V;
        protected static Bitmap CastIcon_E;
        protected static Bitmap CastIcon_Q;
        protected static Bitmap CastIcon_;
        protected static Bitmap CastIcon_\I;
        protected static Bitmap CastIcon_@;
        protected static Bitmap CastIcon_s͌;
        protected static Bitmap CastIcon_s͑;
        protected static Bitmap CastIcon_͌;
        protected static Bitmap CastIcon_͑;
        protected static Bitmap CastIcon_R͌;
        protected static Bitmap CastIcon_R͑;
        protected static Bitmap CastIcon_h͌;
        protected static Bitmap CastIcon_h͑;
        protected static Bitmap CastIcon_b;

        static CharacterCard()
        {
            CastBackgroundImage_o[X = CWIEngine.Properties.Resources.Cast_o[X;
            CastBackgroundImage_ӎs = CWIEngine.Properties.Resources.Cast_ӎs;
            CastBackgroundImage_Ή = CWIEngine.Properties.Resources.Cast_Ή;
            CastBackgroundImage_ = CWIEngine.Properties.Resources.Cast_;
            CastBackgroundImage_ = CWIEngine.Properties.Resources.Cast_;
            CastBackgroundImage_ = CWIEngine.Properties.Resources.Cast_;
            CastBackgroundImage_d = CWIEngine.Properties.Resources.Cast_d;
            CastBackgroundImage_ = CWIEngine.Properties.Resources.Cast_;
            CastBackgroundImage_N = CWIEngine.Properties.Resources.Cast_N;
            CastImage_HPBlock = CWIEngine.Properties.Resources.HPBlock;
            CastImage_HPBlock.MakeTransparent(Color.White);
            CastImage_HPBar = CWIEngine.Properties.Resources.HPBar;
            CastIcon_ = CWIEngine.Properties.Resources.Icon_;
            CastIcon_ = CWIEngine.Properties.Resources.Icon_;
            CastIcon_V = CWIEngine.Properties.Resources.Icon_V;
            CastIcon_E = CWIEngine.Properties.Resources.Icon_E;
            CastIcon_Q = CWIEngine.Properties.Resources.Icon_Q;
            CastIcon_ = CWIEngine.Properties.Resources.Icon_;
            CastIcon_\I = CWIEngine.Properties.Resources.Icon_\I;
            CastIcon_@ = CWIEngine.Properties.Resources.Icon_@;
            CastIcon_s͌ = CWIEngine.Properties.Resources.Icon_s;
            CastIcon_s͌.MakeTransparent(FilePath.CWTransparentColor);
            CastIcon_s͑ = CWIEngine.Properties.Resources.Icon_s;
            CastIcon_s͑.MakeTransparent(FilePath.CWTransparentColor);
            CastIcon_͌ = CWIEngine.Properties.Resources.Icon_;
            CastIcon_͌.MakeTransparent(FilePath.CWTransparentColor);
            CastIcon_͑ = CWIEngine.Properties.Resources.Icon_;
            CastIcon_͑.MakeTransparent(FilePath.CWTransparentColor);
            CastIcon_R͌ = CWIEngine.Properties.Resources.Icon_R;
            CastIcon_R͌.MakeTransparent(FilePath.CWTransparentColor);
            CastIcon_R͑ = CWIEngine.Properties.Resources.Icon_R;
            CastIcon_R͑.MakeTransparent(FilePath.CWTransparentColor);
            CastIcon_h͌ = CWIEngine.Properties.Resources.Icon_h䌸;
            CastIcon_h͌.MakeTransparent(FilePath.CWTransparentColor);
            CastIcon_h͑ = CWIEngine.Properties.Resources.Icon_h䑝;
            CastIcon_h͑.MakeTransparent(FilePath.CWTransparentColor);
            CastIcon_b = CWIEngine.Properties.Resources.Icon_b;
            //[h`FbNׂȂ
        }
        #endregion

        /// <summary>
        /// LN^[f[^
        /// </summary>
        public CharacterData charaData;

        /// <summary>
        /// 퓬̊ɂD
        /// </summary>
        public List<BattleHandCard> battleCards;

        /// <summary>
        /// 퓬̗\DiRDj
        /// </summary>
        public List<GameParam.BattleCardKind> decks;

        /// <summary>
        /// 퓬ɑID
        /// </summary>
        public BattleHandCard selectCard;

        /// <summary>
        /// 퓬ɍs鏢bXg
        /// </summary>
        public List<BattleBeastData> battleBeast;

        // Gyɂ邽߁Aqbg|Cgo[͕BitmapŕێĂ
        protected Bitmap HPBarImage;

        public CharacterCard()
        {
            battleCards = new List<BattleHandCard>();
            decks = new List<GameParam.BattleCardKind>();
            battleBeast = new List<BattleBeastData>();
            selectCard = null;
            cardImage = new Bitmap(CharacterCardWidth, CharacterCardHeight);
            HPBarImage = new Bitmap(HPBarImageWidth, HPBarImageHeight);
        }

        /// <summary>
        /// J[hԂԂǂ
        /// </summary>
        public override bool Reverse
        {
            get
            {
                if (charaData != null)
                    return charaData.IsAbsent;
                else
                    return cardReverse;
            }
        }

        public virtual void RedrawCharacter()
        {
            MakeImage(true);
        }

        /// <summary>
        /// LN^[̏Ԃɉ摜\z
        /// </summary>
        protected void MakeImage(bool showInfo)
        {
            using (Graphics g = Graphics.FromImage(cardImage))
            {
                //J[hwi
                if (charaData == null || charaData.IsAbsent)
                    g.DrawImage(CastBackgroundImage_o[X, 0, 0);
                else if (charaData.HitPoint == 0)
                    g.DrawImage(CastBackgroundImage_ӎs, 0, 0);
                else if (charaData.Paralyse >= CWData.StateParalyseStoned)
                    g.DrawImage(CastBackgroundImage_Ή, 0, 0);
                else if (charaData.Paralyse > 0)
                    g.DrawImage(CastBackgroundImage_, 0, 0);
                else if (charaData.MindStates == CharacterData.StateMind. &&
                    this.charaData.MindRound > 0)
                    g.DrawImage(CastBackgroundImage_, 0, 0);
                else if (charaData.BindRound > 0)
                    g.DrawImage(CastBackgroundImage_, 0, 0);
                else if (charaData.HitPoint < this.charaData.MaxHitPoint / 5)
                    g.DrawImage(CastBackgroundImage_d, 0, 0);
                else if (charaData.HitPoint < this.charaData.MaxHitPoint)
                    g.DrawImage(CastBackgroundImage_, 0, 0);
                else
                    g.DrawImage(CastBackgroundImage_N, 0, 0);
                if (charaData != null && !charaData.IsAbsent)
                {
                    if (!showInfo)
                    {
                        //GG
                        if (!charaData.Image.empty)
                            g.DrawImage(charaData.Image.bitmap, CardGraphicCharacterRect);
                        //J[hG
                        g.DrawString(charaData.CardName, CardStringFont, PartyMaker.BlackBrush, CardStringRect);
                    }
                    else
                    {
                        //xG
                        StringFormat format = new StringFormat();
                        format.Alignment = StringAlignment.Far;
                        g.DrawString(charaData.Level.ToString(), CharacterLevelFont, CharacterLevelBrush, CharacterLevelRect, format);
                        //GG
                        if (!charaData.Image.empty)
                            g.DrawImage(charaData.Image.bitmap, CardGraphicCharacterRect);
                        //J[hG
                        g.DrawString(charaData.CardName, CardStringFont, PartyMaker.BlackBrush, CardStringRect);
                        //HPo[G
                        if (charaData.HitPoint > 0)
                        {//ӎs҂̓o[\Ȃ
                            using (Graphics hpg = Graphics.FromImage(HPBarImage))
                            {
                                hpg.DrawImage(CastImage_HPBar, 79 * charaData.HitPoint / charaData.MaxHitPoint - 79, 1);
                                hpg.DrawImage(CastImage_HPBlock, 0, 0);
                            }
                            HPBarImage.MakeTransparent(HPBarImage.GetPixel(0, 0));
                            g.DrawImage(HPBarImage, 8, 110);
                        }

                        #region ԈُACRG
                        //ԃACRG
                        //ŁE_iȊOjEفE\IE@Es͕ωE
                        //ωERωEhωEb}[Nitj
                        //SA჏Ԃł͓ŃACR̂ݗLiʂ͖ჂLAȊO͏Łj
                        //lK
                        int iconX = 7, iconY = 92, iconYDef = 92, iconYLimit = 20;
                        int iconSize = 16, iconInterval = 17;
                        if (charaData.HitPoint == 0)
                            iconY += 13;//S͂goo[Ȃ
                        if (charaData.Poison > 0)
                        {
                            g.DrawImage(CastIcon_, iconX, iconY);
                            iconY -= iconInterval;
                        }
                        if (charaData.MindRound > 0 && charaData.MindStates == CharacterData.StateMind.Q)
                        {
                            g.DrawImage(CastIcon_Q, iconX, iconY);
                            iconY -= iconInterval;
                        }
                        if (charaData.MindRound > 0 && charaData.MindStates == CharacterData.StateMind.V)
                        {
                            g.DrawImage(CastIcon_V, iconX, iconY);
                            iconY -= iconInterval;
                        }
                        if (charaData.MindRound > 0 && charaData.MindStates == CharacterData.StateMind.)
                        {
                            g.DrawImage(CastIcon_, iconX, iconY);
                            iconY -= iconInterval;
                        }
                        if (charaData.MindRound > 0 && charaData.MindStates == CharacterData.StateMind.E)
                        {
                            g.DrawImage(CastIcon_E, iconX, iconY);
                            iconY -= iconInterval;
                        }
                        if (charaData.SilentRound > 0)
                        {
                            g.DrawImage(CastIcon_, iconX, iconY);
                            iconY -= iconInterval;
                        }
                        if (charaData.DiscloseRound > 0)
                        {
                            g.DrawImage(CastIcon_\I, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        if (charaData.InvalidateMagicRound > 0)
                        {
                            g.DrawImage(CastIcon_@, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        if (charaData.MagicPowerRound > 0 && charaData.MagicPowerBonus < 0)
                        {
                            g.FillRectangle(new SolidBrush(iconColor(charaData.MagicPowerBonus)), iconX, iconY, iconSize, iconSize);
                            g.DrawImage(CastIcon_s͌, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        if (charaData.MagicPowerRound > 0 && charaData.MagicPowerBonus > 0)
                        {
                            g.FillRectangle(new SolidBrush(iconColor(charaData.MagicPowerBonus)), iconX, iconY, iconSize, iconSize);
                            g.DrawImage(CastIcon_s͑, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        if (charaData.MagicAvoidRound > 0 && charaData.MagicAvoidBonus < 0)
                        {
                            g.FillRectangle(new SolidBrush(iconColor(charaData.MagicAvoidBonus)), iconX, iconY, iconSize, iconSize);
                            g.DrawImage(CastIcon_͌, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        if (charaData.MagicAvoidRound > 0 && charaData.MagicAvoidBonus > 0)
                        {
                            g.FillRectangle(new SolidBrush(iconColor(charaData.MagicAvoidBonus)), iconX, iconY, iconSize, iconSize);
                            g.DrawImage(CastIcon_͑, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        if (charaData.MagicResistRound > 0 && charaData.MagicResistBonus < 0)
                        {
                            g.FillRectangle(new SolidBrush(iconColor(charaData.MagicResistBonus)), iconX, iconY, iconSize, iconSize);
                            g.DrawImage(CastIcon_R͌, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        if (charaData.MagicResistRound > 0 && charaData.MagicResistBonus > 0)
                        {
                            g.FillRectangle(new SolidBrush(iconColor(charaData.MagicResistBonus)), iconX, iconY, iconSize, iconSize);
                            g.DrawImage(CastIcon_R͑, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        if (charaData.MagicArmorRound > 0 && charaData.MagicArmorBonus < 0)
                        {
                            g.FillRectangle(new SolidBrush(iconColor(charaData.MagicArmorBonus)), iconX, iconY, iconSize, iconSize);
                            g.DrawImage(CastIcon_h͌, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        if (charaData.MagicArmorRound > 0 && charaData.MagicArmorBonus > 0)
                        {
                            g.FillRectangle(new SolidBrush(iconColor(charaData.MagicArmorBonus)), iconX, iconY, iconSize, iconSize);
                            g.DrawImage(CastIcon_h͑, iconX, iconY);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        //}[N
                        int c = 0;
                        foreach (WidCard beast in charaData.Beasts)
                        {
                            if (beast.HutaiBeast == false)
                                c++;
                        }
                        if (c > 0)
                        {
                            int dx = 7, dy = 4;
                            g.DrawImage(CastIcon_b, iconX, iconY);
                            string s = c.ToString();
                            g.DrawString(s, BeastMarkFont, PartyMaker.BlackBrush, iconX + dx - 1, iconY + dy - 1);
                            g.DrawString(s, BeastMarkFont, PartyMaker.BlackBrush, iconX + dx - 1, iconY + dy);
                            g.DrawString(s, BeastMarkFont, PartyMaker.BlackBrush, iconX + dx - 1, iconY + dy + 1);
                            g.DrawString(s, BeastMarkFont, PartyMaker.BlackBrush, iconX + dx, iconY + dy - 1);
                            g.DrawString(s, BeastMarkFont, PartyMaker.BlackBrush, iconX + dx, iconY + dy + 1);
                            g.DrawString(s, BeastMarkFont, PartyMaker.BlackBrush, iconX + dx + 1, iconY + dy - 1);
                            g.DrawString(s, BeastMarkFont, PartyMaker.BlackBrush, iconX + dx + 1, iconY + dy);
                            g.DrawString(s, BeastMarkFont, PartyMaker.BlackBrush, iconX + dx + 1, iconY + dy + 1);
                            g.DrawString(s, BeastMarkFont, PartyMaker.WhiteBrush, iconX + dx, iconY + dy);
                            iconY -= iconInterval;
                            if (iconY < iconYLimit)
                            {
                                iconY = iconYDef;
                                iconX += iconInterval;
                            }
                        }
                        #endregion
                    }
                }
            }
        }

        /// <summary>
        /// ʋxɉĐFςACRp̐FԂB
        /// </summary>
        /// <param name="value">ʋx</param>
        /// <returns></returns>
        private static Color iconColor(int value)
        {
            if (value >= 10)
                return Color.FromArgb(252, 2, 4);
            if (value >= 7)
                return Color.FromArgb(172, 2, 4);
            if (value >= 4)
                return Color.FromArgb(124, 2, 4);
            if (value >= 1)
                return Color.FromArgb(76, 2, 4);
            if (value >= -3)
                return Color.FromArgb(4, 2, 188);
            if (value >= -6)
                return Color.FromArgb(4, 2, 140);
            if (value >= -9)
                return Color.FromArgb(4, 2, 84);
            return Color.FromArgb(4, 2, 52);
        }

    }//class


    public class BattleBeastData
    {
        public CharacterCard target;
        public WidCard beast;
        public BattleBeastData(WidCard beast)
        {
            this.beast = beast;
            target = null;
        }
    }
}
