/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
using System;
using System.Drawing;
using CWIDatas;

namespace CWI.Card
{
    /// <summary>
    /// DEBhEɕ\J[h
    /// </summary>
    public class HandCard : NormalSizeCard
    {
        #region 萔ƃrbg}bv
        protected static readonly Bitmap SkillBackgroundImage;
        protected static readonly Bitmap ItemBackgroundImage;
        protected static readonly Bitmap BeastBackgroundImage;
        protected static readonly Bitmap HutaiBackgroundImage;
        protected static readonly Bitmap ActionBackgroundImage;
        public static readonly Bitmap[] IconGreen_Bmp;
        protected static readonly Bitmap[] IconRed_Bmp;
        protected static int colorLevelGreen = 5;
        protected static int colorLevelRed = 5;
        protected static readonly Bitmap Deco_Hold;
        protected static readonly Bitmap Deco_Penalty;
        protected static readonly int IconGreenX = 60;
        protected static readonly int IconGreenY = 90;
        protected static readonly int IconRedX = 60;
        protected static readonly int IconRedY = 74;
        protected static readonly Bitmap Deco_Rare;
        protected static readonly Bitmap Deco_Premier;
        protected static readonly Font CountFont;

        static HandCard()
        {
            SkillBackgroundImage = CWIEngine.Properties.Resources.Back_XL;
            ItemBackgroundImage = CWIEngine.Properties.Resources.Back_ACe;
            BeastBackgroundImage = CWIEngine.Properties.Resources.Back_b;
            HutaiBackgroundImage = CWIEngine.Properties.Resources.Back_tє\;
            ActionBackgroundImage = CWIEngine.Properties.Resources.Back_ANV;
            //ACR
            IconGreen_Bmp = new Bitmap[colorLevelGreen];
            IconGreen_Bmp[0] = CWIEngine.Properties.Resources.Icon_K_1;
            if (IconGreen_Bmp[0] != null)
                IconGreen_Bmp[0].MakeTransparent(IconGreen_Bmp[0].GetPixel(0, 0));
            IconGreen_Bmp[1] = CWIEngine.Properties.Resources.Icon_K_2;
            if (IconGreen_Bmp[1] != null)
                IconGreen_Bmp[1].MakeTransparent(IconGreen_Bmp[1].GetPixel(0, 0));
            IconGreen_Bmp[2] = CWIEngine.Properties.Resources.Icon_K_3;
            if (IconGreen_Bmp[2] != null)
                IconGreen_Bmp[2].MakeTransparent(IconGreen_Bmp[2].GetPixel(0, 0));
            IconGreen_Bmp[3] = CWIEngine.Properties.Resources.Icon_K_4;
            if (IconGreen_Bmp[3] != null)
                IconGreen_Bmp[3].MakeTransparent(IconGreen_Bmp[3].GetPixel(0, 0));
            IconGreen_Bmp[4] = CWIEngine.Properties.Resources.Icon_K_5;
            if (IconGreen_Bmp[4] != null)
                IconGreen_Bmp[4].MakeTransparent(IconGreen_Bmp[4].GetPixel(0, 0));
            IconRed_Bmp = new Bitmap[colorLevelRed];
            IconRed_Bmp[0] = CWIEngine.Properties.Resources.Icon_c0;
            if (IconRed_Bmp[0] != null)
                IconRed_Bmp[0].MakeTransparent(IconRed_Bmp[0].GetPixel(0, 0));
            IconRed_Bmp[1] = CWIEngine.Properties.Resources.Icon_c1;
            if (IconRed_Bmp[1] != null)
                IconRed_Bmp[1].MakeTransparent(IconRed_Bmp[1].GetPixel(0, 0));
            IconRed_Bmp[2] = CWIEngine.Properties.Resources.Icon_c2;
            if (IconRed_Bmp[2] != null)
                IconRed_Bmp[2].MakeTransparent(IconRed_Bmp[2].GetPixel(0, 0));
            IconRed_Bmp[3] = CWIEngine.Properties.Resources.Icon_c3;
            if (IconRed_Bmp[3] != null)
                IconRed_Bmp[3].MakeTransparent(IconRed_Bmp[3].GetPixel(0, 0));
            IconRed_Bmp[4] = CWIEngine.Properties.Resources.Icon_c4;
            if (IconRed_Bmp[4] != null)
                IconRed_Bmp[4].MakeTransparent(IconRed_Bmp[4].GetPixel(0, 0));
            //J[h
            Deco_Hold = CWIEngine.Properties.Resources.CardDeco_Hold;
            Deco_Hold.MakeTransparent(Deco_Hold.GetPixel(20, 20));
            Deco_Penalty = CWIEngine.Properties.Resources.CardDeco_Penalty;
            Deco_Penalty.MakeTransparent(Deco_Penalty.GetPixel(20, 20));
            Deco_Rare = CWIEngine.Properties.Resources.CardDeco_Rare;
            Deco_Rare.MakeTransparent(Color.White);
            Deco_Premier = CWIEngine.Properties.Resources.CardDeco_Premier;
            Deco_Premier.MakeTransparent(Color.White);
            CountFont = new Font("Terminal", 9);

        }
        #endregion

        public D type;
        public WidCard widData;
        protected Bitmap cardDecoImage;
        /// <summary>
        /// tH[JXŔ]ȂK񐔂ȂǂG悵rbg}bvB
        /// CardImageɏd˂ĎgpB
        /// </summary>
        public Bitmap CardDecoImage
        {
            get { return cardDecoImage; }
        }

        public HandCard(D ptype, WidCard wc)
        {
            type = ptype;
            cardtype = J[h.DJ[h;
            widData = wc;
            region = null;
            cardDecoImage = new Bitmap(NormalCardWidth, NormalCardHeight);
            
            //J[h摜Giނɂ炸ʁj
            using (Graphics g = Graphics.FromImage(cardImage))
            {
                //J[hwi
                switch (widData.WidID)
                {
                    case WidIDtype.ACe:
                        g.DrawImage(ItemBackgroundImage, 0, 0);
                        break;
                    case WidIDtype.XL:
                        g.DrawImage(SkillBackgroundImage, 0, 0);
                        break;
                    case WidIDtype.b:
                        if (widData.HutaiBeast)
                            g.DrawImage(HutaiBackgroundImage, 0, 0);
                        else
                            g.DrawImage(BeastBackgroundImage, 0, 0);
                        break;
                    case WidIDtype.ANV:
                        g.DrawImage(ActionBackgroundImage, 0, 0);
                        break;
                    default:
                        PartyMaker.CWIErrorMessage("ACeXL킩܂I");
                        break;
                }
                //Aƃv~A
                if (widData.Rarity == 󏭓x.A)
                {
                    g.DrawImage(Deco_Rare, cardImage.Width - Deco_Rare.Width - 5, 5);
                    g.DrawImage(Deco_Rare, 5, cardImage.Height - Deco_Rare.Height - 5);
                }
                if (widData.Rarity == 󏭓x.v~A)
                {
                    g.DrawImage(Deco_Premier, cardImage.Width - Deco_Premier.Width - 5, 5);
                    g.DrawImage(Deco_Premier, 5, cardImage.Height - Deco_Premier.Height - 5);
                }
                //J[hG
                if (!widData.Image.empty)
                {
                    try
                    {
                        g.DrawImage(widData.Image.bitmap, CardGraphicRect);
                    }
                    catch
                    {
                        ;//\ȂɂȂ
                    }
                }
                //J[h
                g.DrawString(widData.CardName, CardStringFont, PartyMaker.BlackBrush, CardStringRect);
            }
        }


    }//class

    public enum D : byte
    { XL, ACe, Lb, ו, 퓬D}
}
