using System;
using System.Drawing;
using CWIDatas;

namespace CWI.Card
{
    class SkillHandCard : HandCard
    {
        public SkillHandCard(WidCard skill)
            : base(D.XL, skill) { }

        /// <summary>
        /// tH[JXŔ]ȂfR[V̉摜쐬B
        /// 摜CardDecoImage\bhŎ擾
        /// </summary>
        /// <param name="green">K̃x</param>
        /// <param name="red">cgp񐔂̃x</param>
        public void UpdateImage(int green, int red)
        {
            if (green < 0)
                green = 0;
            else if (green > colorLevelGreen)
                green = colorLevelGreen;
            if (red < 0)
                red = 0;
            else if (red > colorLevelRed)
                red = colorLevelRed;

            using (Graphics g = Graphics.FromImage(cardDecoImage))
            {
                //Ḱ
                g.DrawImage(IconGreen_Bmp[green], IconGreenX, IconGreenY);
                //XLc񐔂́
                g.DrawImage(IconRed_Bmp[red], IconRedX, IconRedY);
                //z[h
                if (widData.HoldCard)
                    g.DrawImage(Deco_Hold, 0, 0);
                //yieB
                if (Util2.IsPenaltyCard(widData))
                    g.DrawImage(Deco_Penalty, 0, 0);
            }
        }
    }//class
}
