/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
/**
 * AõLN^[f[^
 */
// 06/7/9
//ďC 8/1

using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text;
using System.IO;
using CWIDatas;
using CWI.Dialog;
using CWI.Card;
using System.Text.RegularExpressions;  // for Regex 

namespace CWI
{

    public class AlbumCharacter : DataWithIO
    {
        #region tB[h
        short nazo1_0;
        string characterName;
        ImageData image;
        ushort level_h;
        short avoid_h;
        short resist_h;
        short armor_h;
        short dex_h;
        short spd_h;
        short int_h;
        short str_h;
        short vit_h;
        short mnd_h;
        short warlike_h;
        short cheerful_h;
        short brave_h;
        short careful_h;
        short cunning_h;
        byte resi_physical;
        byte resi_magic;
        byte resi_body;
        byte resi_mind;
        byte weak_unholy;
        byte weak_magiclife;
        byte resi_hot;
        byte resi_cold;
        byte weak_hot;
        byte weak_cold;
        string expression;
        List<CouponData> couponList;
        #endregion

        #region vpeB
        public string Name
        {
            get { return characterName; }
            set { characterName = value; }
        }
        public ImageData Image
        {
            get { return image; }
        }
        public uint Level
        {
            get { return (uint)level_h; }
            set { level_h = (ushort)value; }
        }
        public int AvoidBonus
        {
            get { return (int)avoid_h; }
            set { avoid_h = (short)value; }
        }
        public int ResistBonus
        {
            get { return (int)resist_h; }
            set { resist_h = (short)value; }
        }
        public int ArmorBonus
        {
            get { return (int)armor_h; }
            set { armor_h = (short)value; }
        }
        public int Dex
        {
            get { return (int)dex_h; }
            set { dex_h = (short)value; }
        }
        public int Spd
        {
            get { return (int)spd_h; }
            set { spd_h = (short)value; }
        }
        public int Int
        {
            get { return (int)int_h; }
            set { int_h = (short)value; }
        }
        public int Str
        {
            get { return (int)str_h; }
            set { str_h = (short)value; }
        }
        public int Vit
        {
            get { return (int)vit_h; }
            set { vit_h = (short)value; }
        }
        public int Mnd
        {
            get { return (int)mnd_h; }
            set { mnd_h = (short)value; }
        }
        public int Warlike
        {
            get { return (int)warlike_h; }
            set { warlike_h = (short)value; }
        }
        public int Cheerful
        {
            get { return (int)cheerful_h; }
            set { cheerful_h = (short)value; }
        }
        public int Brave
        {
            get { return (int)brave_h; }
            set { brave_h = (short)value; }
        }
        public int Careful
        {
            get { return (int)careful_h; }
            set { careful_h = (short)value; }
        }
        public int Cunning
        {
            get { return (int)cunning_h; }
            set { cunning_h = (short)value; }
        }
        public bool ResistPhysical
        {
            get { return !(resi_physical == 0); }
            set { resi_physical = (byte)(value ? 1 : 0); }
        }
        public bool ResistMagic
        {
            get { return !(resi_magic == 0); }
            set { resi_magic = (byte)(value ? 1 : 0); }
        }
        public bool ResistBody
        {
            get { return !(resi_body == 0); }
            set { resi_body = (byte)(value ? 1 : 0); }
        }
        public bool ResistMind
        {
            get { return !(resi_mind == 0); }
            set { resi_mind = (byte)(value ? 1 : 0); }
        }
        public bool WeakUnholy
        {
            get { return !(weak_unholy == 0); }
            set { weak_unholy = (byte)(value ? 1 : 0); }
        }
        public bool WeakMagiclife
        {
            get { return !(weak_magiclife == 0); }
            set { weak_magiclife = (byte)(value ? 1 : 0); }
        }
        public bool ResistHot
        {
            get { return !(resi_hot == 0); }
            set { resi_hot = (byte)(value ? 1 : 0); }
        }
        public bool ResistCold
        {
            get { return !(resi_cold == 0); }
            set { resi_cold = (byte)(value ? 1 : 0); }
        }
        public bool WeakHot
        {
            get { return !(weak_hot == 0); }
            set { weak_hot = (byte)(value ? 1 : 0); }
        }
        public bool WeakCold
        {
            get { return !(weak_cold == 0); }
            set { weak_cold = (byte)(value ? 1 : 0); }
        }
        public string Expression
        {
            get { return expression; }
            set { expression = value; }
        }
        public List<CouponData> Coupons
        {
            get
            {
                if (couponList == null)
                    couponList = new List<CouponData>();
                return couponList;
            }
        }
        #endregion

        #region ǉvpeB
        /// <summary>
        /// mȃtpX̃t@C
        /// </summary>
        string fileName = string.Empty;
        public string FileName
        {
            get
            {
                return fileName;
            }
            set
            {
                fileName = value;
            }
        }

        /// <summary>
        /// EP
        /// </summary>
        public int EP
        {
            get
            {
                CouponData cp = GetCouponData(CWData.STR_EP);
                if (cp != null)
                {
                    return cp.Point;
                }
                else
                {
                    return 0;
                }
            }
            set
            {
                SetCoupon(CWData.STR_EP, value);
            }
        }
        #endregion

        #region RXgN^
        public AlbumCharacter() { image = new ImageData(); }

        public AlbumCharacter(string fileName)
        {
            image = new ImageData();
            this.Read(fileName);
            this.FileName = fileName;
        }

        #endregion

        #region [hCg
        public override void Read(System.IO.BinaryReader r)
        {
            nazo1_0 = r.ReadInt16();

            characterName = r.ReadString();
            image.Read(r);
            level_h = r.ReadUInt16();

            avoid_h = r.ReadInt16();
            resist_h = r.ReadInt16();
            armor_h = r.ReadInt16();

            dex_h = r.ReadInt16();
            spd_h = r.ReadInt16();
            int_h = r.ReadInt16();
            str_h = r.ReadInt16();
            vit_h = r.ReadInt16();
            mnd_h = r.ReadInt16();

            warlike_h = r.ReadInt16();
            cheerful_h = r.ReadInt16();
            brave_h = r.ReadInt16();
            careful_h = r.ReadInt16();
            cunning_h = r.ReadInt16();

            resi_physical = r.ReadByte();
            resi_magic = r.ReadByte();
            resi_body = r.ReadByte();
            resi_mind = r.ReadByte();
            weak_unholy = r.ReadByte();
            weak_magiclife = r.ReadByte();
            resi_hot = r.ReadByte();
            resi_cold = r.ReadByte();
            weak_hot = r.ReadByte();
            weak_cold = r.ReadByte();

            expression = ((SjisCBinaryReader)r).ReadStringCRLF();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                CouponData d = new CouponData();
                d.Read(r);
                Coupons.Add(d);
            }
        }
        public override void Write(System.IO.BinaryWriter w)
        {
            w.Write(nazo1_0);
            w.Write(characterName);
            image.Write(w);
            w.Write(level_h);
            w.Write(avoid_h);
            w.Write(resist_h);
            w.Write(armor_h);
            w.Write(dex_h);
            w.Write(spd_h);
            w.Write(int_h);
            w.Write(str_h);
            w.Write(vit_h);
            w.Write(mnd_h);
            w.Write(warlike_h);
            w.Write(cheerful_h);
            w.Write(brave_h);
            w.Write(careful_h);
            w.Write(cunning_h);
            w.Write(resi_physical);
            w.Write(resi_magic);
            w.Write(resi_body);
            w.Write(resi_mind);
            w.Write(weak_unholy);
            w.Write(weak_magiclife);
            w.Write(resi_hot);
            w.Write(resi_cold);
            w.Write(weak_hot);
            w.Write(weak_cold);
            ((SjisCBinaryWriter)w).WriteCRLF(expression);
            w.Write(Coupons.Count);
            foreach (CouponData d in Coupons)
                d.Write(w);
        }



        #endregion

        #region \bh
        /// <summary>
        /// eɂȂ邩
        /// </summary>
        /// <returns></returns>
        public bool CanMakeChild()
        {
            foreach (CouponData cp in this.Coupons)
            {
                if (cp != null)
                {
                    if (cp.Name.StartsWith(CWData.STR_EP))
                    {
                        if (cp.Point >= 10)
                        {
                            return true;
                        }
                        else
                        {
                            return false;
                        }
                    }
                }
            }
            return false;
        }


        /// <summary>
        /// Sex擾
        /// </summary>
        /// <returns></returns>
        public Sex GetSex()
        {
            string s;
            foreach (CouponData cp in this.Coupons)
            {
                if (cp != null)
                {
                    s = cp.Name;
                    if (s.Equals(CWData.STR_MALE))
                    {
                        return Sex.Male;
                    }
                    else if (s.Equals(CWData.STR_FEMALE))
                    {
                        return Sex.Female;
                    }
                }
            }

            return Sex.Common;
        }

        /// <summary>
        /// N[|擾
        /// </summary>
        /// <param name="couponName">N[|</param>
        /// <returns>N[|</returns>
        public CouponData GetCouponData(string couponName)
        {
            foreach (CouponData cp in this.Coupons)
            {
                if (cp.Name.Equals(couponName))
                {
                    return cp;
                }
            }
            return null;
        }

        /// <summary>
        /// N[|ݒ
        /// </summary>
        /// <param name="couponName">N[|</param>
        /// <param name="couponPoint">_</param>
        public void SetCoupon(string couponName, int couponPoint)
        {
            foreach (CouponData cp in this.Coupons)
            {
                if (cp.Name.Equals(couponName))
                {
                    cp.Point = couponPoint;
                    return;
                }
            }

            CouponData cpp = new CouponData();
            cpp.Name = couponName;
            cpp.Point = couponPoint;
            this.Coupons.Add(cpp);
        }

        /// <summary>
        /// f̂N[|擾
        /// </summary>
        /// <returns></returns>
        public string GetGeneString()
        {
            string s;
            foreach (CouponData cp in this.Coupons)
            {
                if (cp != null)
                {
                    s = cp.Name;
                    if (Regex.IsMatch(s, CWData.GENE_HEADER))
                    {
                        return s;
                    }
                }
            }

            return CWData.GENE_HEADER + "0000000000";
        }

        #endregion
    }//class AlbumCharacter
}
