using System;
using System.IO;
using CWIDatas;

namespace CWI
{
    public class CharacterName : DataWithIO
    {
        #region vpeB
        /// <summary>
        /// LN^
        /// </summary>
        public string Name
        {
            get { return characterName; }
            set { characterName = value; }
        }
        string characterName;

        public string FileName
        {
            get { return filename; }
            set { filename = value; }
        }
        private string filename;
        #endregion

        #region RXgN^

        public CharacterName(string file)
        {
            try
            {
                this.Read(file);
            }
            catch (Exception ex)
            {
                PartyMaker.CWIErrorMessage("ҋ@o[t@C̓ǂݍ݂ɎsF" + ex.Message);
            }
        }

        #endregion

        #region [hCg

        public override void Read(string file)
        {
            FileName = file;
            base.Read(file);
        }

        public override void Read(System.IO.BinaryReader r)
        {
            Stream stream = r.BaseStream;
            //nazo1_0
            int nazo1_0 = r.ReadInt16();

            if (nazo1_0 == 15)
            {
                int nazo1_1 = r.ReadInt16();
                string versionString = ((SjisCBinaryReader)r).ReadBytesString(nazo1_0);
            }

            //stream.Seek(2, SeekOrigin.Current);

            characterName = r.ReadString();

        }
        public override void Write(System.IO.BinaryWriter w)
        {
        }
        #endregion
    }
}
