/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using System.Drawing;
using System.Windows.Forms;

namespace CWI.Dialog
{
    /// <summary>
    /// Description of MessageDlg.
    /// </summary>
    public partial class MessageDlg
    {
        public static MessageDlg messageDlg;

        private static Font messageFont = new Font(FontFamily.GenericSansSerif, 9, FontStyle.Bold);
        private static Brush messageBrush = new SolidBrush(Color.Black);
        private static Rectangle messageRect = new Rectangle(15, 10, 300, 50);
        private static StringFormat format = new StringFormat();

        public MessageDlg()
        {
            messageDlg = this;

            //
            // The InitializeComponent() call is required for Windows Forms designer support.
            //
            InitializeComponent();

            this.BackgroundImage = CWIEngine.Properties.Resources.MessageDlgBackGround;
        }
        
        public string message;

        /// <summary>
        /// bZ[W_CAOgpɂ́Ã\bhʂă_CAOIuWFNg擾B
        /// iۂɂ̓IuWFNg͗BŌڂύXėpBj
        /// </summary>
        /// <param name="i"></param>
        /// <returns></returns>
        public static MessageDlg GetMessageDlg(Kind i)
        {
            if (messageDlg == null)
                return null;
            switch (i)
            {
                case Kind.Q[I:
                    messageDlg.buttonYes.Visible = true;
                    messageDlg.buttonNo.Visible = true;
                    messageDlg.buttonClose.Visible = false;
                    messageDlg.message = "J[h[XI܂B낵łH";
                    break;
                case Kind.^Cgɖ߂:
                    messageDlg.buttonYes.Visible = true;
                    messageDlg.buttonNo.Visible = true;
                    messageDlg.buttonClose.Visible = false;
                    messageDlg.message = "^Cgʂɖ߂܂BۑĂȂf[^͑SďĂ܂܂B낵łH";
                    break;
                case Kind.Dt:
                    messageDlg.buttonYes.Visible = false;
                    messageDlg.buttonNo.Visible = false;
                    messageDlg.buttonClose.Visible = true;
                    messageDlg.message = "̎D͈tł";
                    break;
                case Kind.J[hgpmF:
                    messageDlg.buttonYes.Visible = true;
                    messageDlg.buttonNo.Visible = true;
                    messageDlg.buttonClose.Visible = false;
                    messageDlg.message = "gp܂B낵łH";
                    break;
                case Kind.`ҍ폜:
                    messageDlg.buttonYes.Visible = true;
                    messageDlg.buttonNo.Visible = true;
                    messageDlg.buttonClose.Visible = false;
                    messageDlg.message = "폜܂B낵łH";
                    break;
                case Kind.mF:
                    messageDlg.buttonYes.Visible = true;
                    messageDlg.buttonNo.Visible = true;
                    messageDlg.buttonClose.Visible = false;
                    messageDlg.message = "܂B낵łH";
                    break;

            }

            return messageDlg;
        }

        public static MessageDlg GetFreeDialog(string message, bool isYes, bool isNo, bool isClose)
        {

            if (messageDlg == null)
                return null;
            format.Alignment = StringAlignment.Center;
            messageDlg.buttonYes.Visible = isYes;
            messageDlg.buttonNo.Visible = isNo;
            messageDlg.buttonClose.Visible = isClose;
            messageDlg.message = message;

            return messageDlg;
        }

        public static DialogResult ShowYesNoDialog(string message)
        {
            DialogResult ret;
            MessageDlg dlg = GetFreeDialog(message, true, true, false);
            if (dlg != null)
            {
                ret = dlg.ShowDialog();
            }
            else
            {
                ret = DialogResult.No;
            }

            return ret;
        }

        public static void ShowInfoDialog(string message)
        {
            MessageDlg dlg = GetFreeDialog(message, false, false, true);
            if (dlg != null)
            {
                dlg.ShowDialog();
            }
        }

        public enum Kind
        {
            Q[I = 0, ^Cgɖ߂, Dt, J[hgpmF, `ҍ폜, mF
        }

        private void MessageDlg_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawString(message, messageFont, messageBrush, messageRect, format);
        }


    }//class MessageDlg


}//namespace
