/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using System.Runtime.InteropServices;
using System.Text;

namespace CWI
{
    /// <summary>
    /// Description of MultiMedia.
    /// </summary>
    public static class MultiMedia
    {
        static string currentPlayingFile = null;
        //static int baseBGMVolume = 478;
        static int changedBGMVolume = -1;
        static int changedSEVolume = -1;
        // static StringBuilder sb = new StringBuilder(32);  // mciSendString() 
        //   Return String i[p

        public static void PlayMusicFile(string file, bool mute)
        {
            bool first = false;
            if (changedBGMVolume == -1)
            {
                // BGMl擾
                StringBuilder buff = new StringBuilder();
                Sound_open(FilePath.GetDataMidiFolder() + "\\DefReset.mid");
                mciSendString("status my_sound volume", buff, buff.Capacity, IntPtr.Zero);
                string bgmValue = buff.ToString();
                try
                {
                    int val = int.Parse(bgmValue);
                    changedBGMVolume = val;
                }
                catch (Exception)
                {
                    changedBGMVolume = 0;
                }
                Sound_close();
                first = true;
            }

            if (first)
            {
                SetBGMInit();
            }

            if (mute)
            {
                Sound_stop();
                Sound_close();
                currentPlayingFile = null;
                return;
            }

            if (file == currentPlayingFile)
                return;
            if (currentPlayingFile != null)
            {
                Sound_stop();
                Sound_close();
            }
            currentPlayingFile = file;
            Sound_open(file);
            Sound_play();
            
        }

        static void SetBGMInit()
        {

            //cwex.ini ꍇAʂɍ킹
            if (System.IO.File.Exists(FilePath.ApplicationFolder + 
                "\\cwex.ini"))
            {
                try
                {
                    string[] lines = System.IO.File.ReadAllLines(FilePath.ApplicationFolder + 
                        "\\cwex.ini");
                    foreach (string cwexLine in lines)
                    {
                        string[] splitData = cwexLine.Split('=');
                        if (splitData.Length == 2)
                        {
                            int value = 100;
                            if (splitData[0] == "VolumeBGM")
                            {
                                value = int.Parse(splitData[1]);
                                if (value >= 0 && value <= 100)
                                {
                                    changedBGMVolume = value;
                                }
                            }
                        }
                    }
                }
                catch (Exception)
                {
                    // X[
                }
            }
            //CardWirth.cfg ꍇAʂɍ킹
            else if (System.IO.File.Exists(FilePath.ApplicationFolder +
                "\\CardWirth.cfg"))
            {
                try
                {
                    string[] lines = System.IO.File.ReadAllLines(FilePath.ApplicationFolder +
                        "\\CardWirth.cfg");
                    foreach (string cwexLine in lines)
                    {
                        string[] splitData = cwexLine.Split('=');
                        if (splitData.Length == 2)
                        {
                            int value = 100;
                            if (splitData[0] == "MusicVol")
                            {
                                value = int.Parse(splitData[1]);
                                if (value >= 0 && value <= 100)
                                {
                                    changedBGMVolume = value;
                                }
                            }
                        }
                    }
                }
                catch (Exception)
                {
                    // X[
                }
            }
        }

        static void SetSEInit()
        {
            //cwex.ini ꍇAʂɍ킹
            if (System.IO.File.Exists(FilePath.ApplicationFolder +
                "\\cwex.ini"))
            {
                try
                {
                    string[] lines = System.IO.File.ReadAllLines(FilePath.ApplicationFolder +
                        "\\cwex.ini");
                    foreach (string cwexLine in lines)
                    {
                        string[] splitData = cwexLine.Split('=');
                        if (splitData.Length == 2)
                        {
                            int value = 100;
                            if (splitData[0] == "VolumeSE")
                            {
                                value = int.Parse(splitData[1]);
                                if (value >= 0 && value <= 100)
                                {
                                    changedSEVolume = value;
                                }
                            }
                        }
                    }
                }
                catch (Exception)
                {
                    // X[
                }
            }
        }

        public static void SoundClick()
        {
            SoundWavFile(FilePath.GetWaveClick());
        }
        public static void SoundWavFile(string file)
        {

            bool first = false;
            if (changedSEVolume == -1)
            {
                
                // SEl擾
                try
                {
                    waveOutGetVolume(0, out uint currVol);
                    ushort calcVol = (ushort)(currVol & 0x0000ffff);
                    changedSEVolume = calcVol / (ushort.MaxValue / 100);
                }
                catch (Exception)
                {
                    changedSEVolume = 0;
                }
                
                first = true;
            }

            if (first)
            {
                SetSEInit();
            }

            //SEʐݒ
            int newVolume = ((ushort.MaxValue / 100) * changedSEVolume);
            uint newVolumeAllChannels = (((uint)newVolume & 0x0000ffff) | ((uint)newVolume << 16));
            waveOutSetVolume(0, newVolumeAllChannels);

            //SEĐ
            PlaySound(file, IntPtr.Zero, SND_FILENAME | SND_ASYNC);
        }

        [DllImport("winmm.dll")]
        extern static int PlaySound(string s1, IntPtr i1, int i2);
        // Ԃl = true @I, false @G[
        // s1 = Sound File Name / Resource ID
        // i1 = Instance Handle @SND_RESOURCE
        // i2 = Flags()
        // const int SND_SYNC = 0x00000;  // Đ  (ĐIɐԂ)
        const int SND_ASYNC = 0x00001;  // 񓯊Đ(ɐԂ)
        // const int SND_LOOP = 0x00008;  // JԂĐ
        const int SND_FILENAME = 0x20000;  // s1  Sound File Name
        // const int SND_RESOURCE = 0x40004;  // s1  Resource ID

        //ʐݒ
        [DllImport("winmm.dll")]
        extern static int waveOutSetVolume(int uDeviceID, uint dwVolume);

        //ʎ擾
        [DllImport("winmm.dll")]
        extern static int waveOutGetVolume(int uDeviceID, out uint lpdwVolume);

        [DllImport("winmm.dll")]
        public static extern int midiOutSetVolume(IntPtr hwo, uint dwVolume);
        //ȉMIDItɊւR[h
        //EFuy[Wu΂̃oCNv́u߂Ă̂bv̍QƂ܂
        //http://homepage3.nifty.com/midori_no_bike/CS/

        [DllImport("winmm.dll")]
        extern static int mciSendString(string s1, StringBuilder s2, int i1, IntPtr i2);
        // Ԃl = 0 @I
        // s1     = Command String
        // s2     = Return String
        // i1     = Return String Size
        // i2     = Callback Hwnd
        private static int Sound_open(string fileName)
        {
            // t@C open
            int ret = mciSendString("open \"" + fileName + "\" alias my_sound type mpegvideo", null, 0, IntPtr.Zero);

            return ret;
            /* ) alias ŁAfoCX my_sound ƒ`B̓Kȕł OKB*/
        }
        //type mpegvideorepeatTips͑̂ǂ̌fQ
        public static void Sound_close()
        {
            // t@C close
            mciSendString("close my_sound", null, 0, IntPtr.Zero);
        }
        private static void Sound_play()
        {
            // ʐݒ
            // MCI ́@0-1000 Ȃ̂10{邳̂ł̂܂܂ɂAmidił͌݌ȂB
            mciSendString("setaudio my_sound volume to " + (changedBGMVolume / 100) , null, 0, IntPtr.Zero);

            // ĐJn
            mciSendString("play my_sound repeat", null, 0, IntPtr.Zero);
        }
        private static void Sound_stop()
        {
            // ~
            mciSendString("stop my_sound", null, 0, IntPtr.Zero);
        }

        // OStop邽߂̃\bh
        public static void SoundStop()
        {
            Sound_stop();
            Sound_close();
            currentPlayingFile = null;
        }

    }//class
}//namespace
