/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
using System;
using System.Collections.Generic;
using System.IO;

namespace CWIDatas
{
    public class MenuData : DataWithIO
    {
        #region tB[h
        byte kindp;
        ImageData image;
        string name;
        uint version;
        string expression;
        List<EventData> eventList;
        string flag;
        uint scale;
        int left;
        int top;
        string imageFile;
        #endregion

        #region vpeB
        public ImageData Image
        {
            get { return image; }
        }
        /// <summary>
        /// j[J[h
        /// </summary>
        public string CardName
        {
            get { return name; }
            set { value = name; }
        }
        public uint Version
        {
            get { return version; }
            set { version = value; }
        }
        /// <summary>
        /// J[h
        /// </summary>
        public string Expression
        {
            get { return expression; }
            set { expression = value; }
        }
        public List<EventData> Events
        {
            get
            {
                if (eventList == null)
                    eventList = new List<EventData>();
                return eventList;
            }
        }
        /// <summary>
        /// QƃtO
        /// </summary>
        /// <param name="w"></param>
        public string FlagName
        {
            get { return flag; }
            set { flag = value; }
        }
        /// <summary>
        /// J[hTCYBXP[BP
        /// </summary>
        public uint Scale
        {
            get { return scale; }
            set
            {
                if (value < CWData.CardScaleMin)
                    scale = CWData.CardScaleMin;
                else if (value > CWData.CardScaleMax)
                    scale = CWData.CardScaleMax;
                else
                    scale = value;
            }
        }
        public int Left
        {
            get { return left; }
            set { left = value; }
        }
        public int Top
        {
            get { return top; }
            set { top = value; }
        }
        /// <summary>
        /// C[WQƂ̏ꍇ̉摜t@C
        /// </summary>
        public string ImageFileName
        {
            get { return imageFile; }
            set { imageFile = value; }
        }
        #endregion

        public MenuData() { image = new ImageData(); }

        #region [hCg
        public override void Read(BinaryReader r)
        {
            kindp = r.ReadByte();
            image.Read(r);
            name = r.ReadString();
            version = r.ReadUInt32();
            expression = r.ReadString();
            uint count = r.ReadUInt32();
            for (; count > 0; count--)
            {
                EventData ev = new EventData();
                ev.Read(r);
                Events.Add(ev);
            }
            flag = r.ReadString();
            scale = r.ReadUInt32();
            left = r.ReadInt32();
            top = r.ReadInt32();
            if (Version > CWData.VersionOffset * 2)
            {
                imageFile = r.ReadString();
            }
        }
        public override void Write(BinaryWriter w)
        {
            w.Write(kindp);
            image.Write(w);
            w.Write(name);
            w.Write(version);
            w.Write(expression);
            w.Write(Events.Count);
            foreach (EventData ev in Events)
                ev.Write(w);
            w.Write(flag);
            w.Write(scale);
            w.Write(left);
            w.Write(top);
            if (Version > CWData.VersionOffset * 2)
            {
                w.Write(imageFile);
            }
        }
        #endregion

    }//class MenuData
}
