
using System;
using System.Collections.Generic;

namespace CWIDatas
{

    /// <summary>
    /// J[h̃t@Cf[^
    /// </summary>
    public class WidInfo : DataWithIO
    {
        #region vpeB

        /// <summary>
        /// J[h͂SŒ̂͂EE
        /// </summary>
        public WidIDtype WidID
        {
            get { return (WidIDtype)widid; }
        }
        byte widid;

        /// <summary>
        /// C[W
        /// </summary>
        public ImageData Image
        {
            get { return image; }
        }
        ImageData image = new ImageData();

        /// <summary>
        /// J[h̖O
        /// </summary>
        public string CardName
        {
            get { return name; }
            set { name = value; }
        }
        string name;

        /// <summary>
        /// o[W
        /// </summary>
        public uint Version
        {
            get { return numberANDversion / CWData.VersionOffset; }
            set { numberANDversion = FileNumber + value * CWData.VersionOffset; }
        }
        uint numberANDversion;
        /// <summary>
        /// J[hԍ
        /// </summary>
        public uint FileNumber
        {
            get { return numberANDversion % CWData.VersionOffset; }
            set { numberANDversion = value + Version * CWData.VersionOffset; }
        }

        /// <summary>
        /// J[h
        /// </summary>
        public string Expression
        {
            get { return expression; }
            set { expression = value; }
        }
        string expression;

        #endregion

        public WidInfo() {  }

        #region [hCg
        public override void Read(System.IO.BinaryReader r)
        {
            widid = r.ReadByte();
            image.Read(r);
            name = r.ReadString();
            numberANDversion = r.ReadUInt32();
            expression = r.ReadString();
        }
        public override void Write(System.IO.BinaryWriter w)
        {
            w.Write(widid);
            image.Write(w);
            w.Write(name);
            w.Write(numberANDversion);
            w.Write(expression);
        }
        #endregion

    }//classs WidInfo
}
