using System;
using System.Collections.Generic;
using System.Text;

namespace CWI.Button
{
    public class TabList
    {
        private List<PanelButtonTabkey> list = new List<PanelButtonTabkey>();

        private PanelButtonTabkey _focus;
        private PanelButtonTabkey focus
        {
            get { return _focus; }
            set
            {
                _focus = value;
                
            }
        }
        //Ce[^
        public IEnumerator<PanelButtonTabkey> GetEnumerator()
        {
            foreach (PanelButtonTabkey bc in list)
                yield return bc;
        }
        //CfNT
        public PanelButtonTabkey this[int i]
        {
            get { return list[i]; }
            set { list[i] = value; }
        }

        public void Add(PanelButtonTabkey item)
        {
            list.Add(item);
        }

        public void Remove(PanelButtonTabkey item)
        {
            list.Remove(item);
        }

        public void RemoveAt(int i)
        {
            list.RemoveAt(i);
        }

        public int Count
        {
            get { return list.Count; }
        }
        private void redraw()
        {
            focus.Invalidate();
            focus.Update();
        }

        public void FocusNext()
        {
            if (list.Count == 0)
                return;
            if (focus == null)
            {
                focus = list[0];
                redraw();
                return;
            }
            if (list.Count == 1)
                return;
            redraw();
            int idx = list.IndexOf(focus);
            if (idx == list.Count - 1)
                focus = list[0];
            else
                focus = list[idx + 1];
            redraw();
        }
        public void FocusPrev()
        {
        }

        public void UnsetFocus()
        {
            if (focus != null)
                redraw();
            focus = null;
        }
    }
}
