using System;
using System.Drawing;
using CWIDatas;

namespace CWI.Card
{
    public class BagHandCard : HandCard
    {
        /// <summary>
        /// וܓŎg郊l[ꂽt@CJ[hf[^
        /// </summary>
        public RenamedCardData bagCardData;

        public BagHandCard(WidCard wid, RenamedCardData renamedCard)
            : base(D.ו, wid)
        {
            bagCardData = renamedCard;
        }

        /// <summary>
        /// tH[JXŔ]ȂfR[V̉摜쐬B
        /// 摜CardDecoImage\bhŎ擾
        /// </summary>
        public void UpdateImage()
        {
            //tH[JXŔ]ȂfR[VG
            using (Graphics g = Graphics.FromImage(cardDecoImage))
            {
                //yieB
                if (Util2.IsPenaltyCard(widData))
                {
                    g.DrawImage(Deco_Penalty, 0, 0);
                }
                //
                if (widData.WidID == WidIDtype.ACe ||
                    widData.WidID == WidIDtype.b)
                {
                    Brush col = null;
                    string s = null;
                    uint count = 0;
                    if (Util2.IsRecycleCard(widData) &&
                        !(widData.WidID == WidIDtype.b && !widData.HutaiBeast))
                    {//TCNJ[hib͈Ⴄj
                        col = new SolidBrush(Color.Yellow);
                        count = widData.ItemRemainUseCount;
                        s = count.ToString();
                    }
                    else if (bagCardData.UseCount > 0)
                    {//ʏJ[hŉ񐔂
                        col = PartyMaker.WhiteBrush;
                        count = bagCardData.UseCount;
                        s = count.ToString();
                    }
                    if (col != null)
                    {
                        Font CountFont = new Font("lr o", 12, FontStyle.Bold);

                        StringFormat format = new StringFormat();
                        int x = 4, y = 90, w = 27, h = CountFont.Height;
                        format.Alignment = StringAlignment.Near;
                        if (count >= 100)
                        {
                            x = 2;
                            w = 35;
                        }
                        Rectangle rec;
                        rec = new Rectangle(x - 1, y - 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x - 1, y, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x - 1, y + 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x, y - 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x, y + 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x + 1, y - 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x + 1, y, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x + 1, y + 1, w, h);
                        g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                        rec = new Rectangle(x, y, w, h);
                        g.DrawString(s, CountFont, col, rec, format);
                    }
                }
            }
        }
    }//class
}
