using System;
using System.Drawing;
using CWIDatas;

namespace CWI.Card
{
    class ItemHandCard : HandCard
    {
        public ItemHandCard(WidCard item)
            : base(D.ACe, item) { }

        /// <summary>
        /// tH[JXŔ]ȂfR[V̉摜쐬B
        /// 摜CardDecoImage\bhŎ擾
        /// </summary>
        /// <param name="green">K̃x</param>
        public void UpdateImage(int green)
        {
            if (green < 0)
                green = 0;
            else if (green > colorLevelGreen)
                green = colorLevelGreen;

            using (Graphics g = Graphics.FromImage(cardDecoImage))
            {
                //Ḱ
                g.DrawImage(IconGreen_Bmp[green], IconGreenX, IconGreenY);
                //z[h
                if (widData.HoldCard)
                    g.DrawImage(Deco_Hold, 0, 0);
                //yieB
                if (Util2.IsPenaltyCard(widData))
                    g.DrawImage(Deco_Penalty, 0, 0);
                //
                Brush col = null;
                if (Util2.IsRecycleCard(widData))
                {//TCNJ[h
                    col = new SolidBrush(Color.Yellow);
                }
                else if (widData.ItemRemainUseCount > 0)
                {//ʏJ[hŉ񐔂
                    col = PartyMaker.WhiteBrush;
                }
                if (col != null)
                {
                    Font CountFont = new Font("lr o", 12, FontStyle.Bold);

                    StringFormat format = new StringFormat();
                    format.Alignment = StringAlignment.Near;
                    string s = widData.ItemRemainUseCount.ToString();
                    int x = 4, y = 90, w = 27, h = CountFont.Height;
                    if (widData.ItemRemainUseCount >= 100)
                    {
                        x = 2;
                        w = 35;
                    }
                    Rectangle rec;
                    rec = new Rectangle(x - 1, y - 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x - 1, y, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x - 1, y + 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x, y - 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x, y + 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x + 1, y - 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x + 1, y, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x + 1, y + 1, w, h);
                    g.DrawString(s, CountFont, PartyMaker.BlackBrush, rec, format);
                    rec = new Rectangle(x, y, w, h);
                    g.DrawString(s, CountFont, col, rec, format);

                }
            }
        }

    }//class
}
