using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using CWIDatas;
//߂ĂC# `o`@http://homepage3.nifty.com/midori_no_bike/CS/ 
using System.Text.RegularExpressions;  // for Regex 

namespace CWI.Dialog
{
    public partial class AlbumDlg : CWI.Dialog.SelectableForm
    {
        private InnData inn;
        public AlbumDlg()
        {
            InitializeComponent();
            SetUpPosition();//ʒu킹
        }

        public AlbumDlg(InnData inn)
        {
            InitializeComponent();
            SetUpPosition();//ʒu킹
            this.inn = inn;
        }

        private AlbumCharacter[] datas;
        private void AlbumDlg_Shown(object sender, EventArgs e)
        {
            index = 0;
            count = 0;
            foreach (string folder in Directory.GetFiles(inn.TempFolder, FilePath.MaskAlbumCharacterData))
            {
                count++;
            }
            if (count == 0)
            {
                base.ShowPage();
                return;
            }
            datas = new AlbumCharacter[count];

            foreach (string file in Directory.GetFiles(inn.TempFolder, FilePath.MaskAlbumCharacterData))
            {
                AlbumCharacter chara = new AlbumCharacter();
                try
                {
                    chara.Read(file);
                }
                catch (Exception ex)
                {
                    PartyMaker.CWIErrorMessage("Aoo[t@C̓ǂݍ݂ɎsF" + ex.Message);
                }
                datas[index++] = chara;
            }
            index = 0;
            ShowPage();
        }

        protected override void ShowPage()
        {
            base.ShowPage();

            if(count == 0)
                return;

            using (Graphics g = Graphics.FromImage(ViewBitmap))
            {
                using (Bitmap book = (Bitmap)Image.FromFile(FilePath.GetBookFile()))//wi\
                {
                    g.DrawImage(book, ViewPanel.ClientRectangle);
                }

				StringFormat format = new StringFormat();//VKtH[}bg
				format.Alignment = StringAlignment.Center;//

				using( Font smallFont = new Font("lr ", 9, FontStyle.Bold) )
				{
                    int y = 125;
                    string sex = "";
                    string age = "";
                    int ep = 0;
                    foreach (CouponData coupon in datas[index].Coupons)
                    {
                        string s = coupon.Name;
                        int p = coupon.Point;
                        if (!Regex.IsMatch(s, "(Q|)"))
                        {//sɁ@Q܂܂ĂȂ
                            g.DrawString(s, smallFont, SolidBlack, 280, y);
                            y += 15;
                        }
                        else
                        {//Qf
                            if (s.Equals(CWData.STR_MALE)) { sex = "Male"; }
                            if (s.Equals(CWData.STR_FEMALE)) { sex = "Female"; }
                            if (s.Equals(CWData.STR_CHILD)) { age = "Child"; }
                            if (s.Equals(CWData.STR_YOUNG)) { age = "Young"; }
                            if (s.Equals(CWData.STR_ADULT)) { age = "Adult"; }
                            if (s.Equals(CWData.STR_OLD)) { age = "Old"; }
                            if (s.Equals(CWData.STR_EP)) { ep = p; }
                        }
                        if (y >= 250) { break; }
                    }
                    g.DrawString("Level", smallFont, SolidBlack, 70, 47);
                    g.DrawString("Adventurer", smallFont, SolidBlack, 131, 47);
                    g.DrawString("History", smallFont, SolidBlack, 301, 112);
                    g.DrawString("Age", smallFont, SolidBlack, 104, 199);
                    g.DrawString(age, smallFont, SolidBlack, 130, 199);
                    g.DrawString("Sex", smallFont, SolidBlack, 104, 214);
                    g.DrawString(sex, smallFont, SolidBlack, 130, 214);
                    g.DrawString("EP", smallFont, SolidBlack, 111, 229);
                    g.DrawString(ep + " ", smallFont, SolidBlack, 135, 229);

                    Rectangle rectCount = new Rectangle(0, 254, this.ClientSize.Width, smallFont.Height);//͈͂̐ݒ
                    g.DrawString((index + 1) + " / " + count, smallFont, SolidBlack, rectCount, format);//ViI̕`
                }
				using( Font levelFont = new Font("lr ", 16, FontStyle.Bold) )
				{//ς
					g.DrawString( datas[index].Level + " " , levelFont, SolidBlack, 100, 40);//xBZ^O
				}

                using (Font largeFont = new Font(FontFamily.GenericMonospace, 16))
                {
					g.DrawString(datas[index].Name, largeFont, SolidBlack, 110, 70);//O
                }

                //摜BȂꍇĂ̂ȁH
                if (!datas[index].Image.empty)
                    g.DrawImage(datas[index].Image.bitmap, 93, 91);

				format.Dispose();//tH[}bg
            }
            ViewPanel.Invalidate();
        }
    }
}