using System;
using System.Drawing;
using System.Windows.Forms;
using CWI;
using CWIDatas;

namespace CWI.Dialog
{
    public partial class PartyDataDlg : Form
    {
        private InnData inn;
        public PartyDataDlg(InnData inn)
        {
            InitializeComponent();// ʒu킹
            this.inn = inn;
            this.BackgroundImage = CWIEngine.Properties.Resources.MessageDlgBackGround;// tH[̔wiς


            hSBMoney.Maximum = (int)(inn.CurrentParty.Money + inn.YadoMoney);// ől͏ĥ{p[eB̏
            hSBMoney.Value = (int)inn.CurrentParty.Money;// o[̈ʒu͏

        }

        // {^
        private void BtnOK_Click(object sender, EventArgs e)
        {
            inn.CurrentParty.PartyName = PartyName.Text;// p[eB
            inn.CurrentParty.Money = (uint)hSBMoney.Value;// p[eB̏
            inn.YadoMoney = (uint)hSBMoney.Maximum - (uint)hSBMoney.Value;// ĥ

            this.DialogResult = DialogResult.OK;
        }

        // \
        private void PartyDataDlg_Shown( object sender, EventArgs e )
        {
            // \
            PartyName.Text = inn.CurrentParty.PartyName;// p[eBǂݏo
            LblPartyMoney.Text = inn.CurrentParty.Money + Util1.MoneyUnit;// 
            LblYadoMoney.Text = inn.YadoMoney + Util1.MoneyUnit;// 
        }

        // o[XN[Ƃ
        private void hSBMoney_Scroll( object sender, ScrollEventArgs e )
        {
            LblPartyMoney.Text = hSBMoney.Value + Util1.MoneyUnit;// 
            LblYadoMoney.Text = (hSBMoney.Maximum - hSBMoney.Value) + Util1.MoneyUnit;// ől珊̕
        }

        // ͂Ƃ
        private void PartyName_TextChanged( object sender, EventArgs e )
        {
            // eLXgȂ{^Ȃ
            if( PartyName.Text == "" )
            {
                BtnOK.Enabled = false;
            }
            else
            {
                BtnOK.Enabled = true;
            }
        }
    }
}
