/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using System.Resources;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;
using CWIDatas;

namespace CWI.Dialog
{
    public partial class ScenarioSelectDlg : CWI.Dialog.SelectableForm
    {
        public ScenarioSelectDlg()
        {
            InitializeComponent();
            SetUpPosition();//ʒu킹
        }

        private ScenarioSelectData[] datas;
        public ScenarioSelectData selectedData;

        private void ScenarioSelectDlg_Shown(object sender, EventArgs e)
        {
            index = 0;//ݒn
            count = 0;//ViI̐
            foreach (string folder in Directory.GetDirectories(FilePath.GetSystemScenarioFolder()))
            {
                count++;
            }
            if (count == 0)
            {
                BtnSelect.Enabled = false;
                return;
            }
            datas = new ScenarioSelectData[count];

            foreach (string folder in Directory.GetDirectories(FilePath.GetSystemScenarioFolder()))
            {
                ScenarioSelectData ssd = new ScenarioSelectData();
                ssd.folder = folder;
                datas[index++] = ssd;
            }
            index = 0;
            ShowPage();
        }

        protected override void ShowPage()
        {
            if (count == 0)
            {
                //TODO ocXW
                return;
            }

            if (!Directory.Exists(datas[index].folder))
            {//tH_̂폜ꂽ
                datas[index].summary = null;
                datas[index].contents = null;
                datas[index].summaryReadError = false;
            }

            //ViI̒ǉ폜ɑΉł悤ɁA\ɏ擾
            if (File.Exists(FilePath.GetSummaryFile(datas[index].folder)))
            {//ViItH_ł
                SummaryData summary = new SummaryData();
                try
                {
                    summary.Read(FilePath.GetSummaryFile(datas[index].folder));
                    datas[index].summary = summary;
                    datas[index].contents = null;
                }
                catch
                {
                    //ǂݍ݂Ɏs\
                    datas[index].summary = null;
                    datas[index].contents = null;
                    datas[index].summaryReadError = true;
                }
            }
            else
            {//̃tH_ł
                datas[index].summary = null;
                datas[index].contents = new StringCollection();
            }

            using (Graphics g = Graphics.FromImage(ViewBitmap))
            {
                Bitmap bill = (Bitmap)Image.FromFile(FilePath.GetBillFile());//ݒ
                g.DrawImage(bill, ViewPanel.ClientRectangle);//wi̕\Ǝv
                bill.Dispose();//

                if (datas[index].summary != null)//summary邩ŃViI
                {//ViIł
                    this.BtnSelect.Text = "";
                    bool abort = FilePath.CheckScenaFolder(datas[index].folder);
                    this.BtnCancel.Text = abort ? "~" : "߂";

                    StringFormat format = new StringFormat();//VKtH[}bg
                    format.Alignment = StringAlignment.Center;//

                    Font scenarioName = new Font("lr o", 18, FontStyle.Bold);//ViĨtHg
                    Rectangle rectScenarioName = new Rectangle(0, 36, this.ClientSize.Width, scenarioName.Height);//͈͂̐ݒ
                    g.DrawString(datas[index].summary.ScenarioName, scenarioName, SolidBlack, rectScenarioName, format);//ViI`-center
                    scenarioName.Dispose();//ViĨtHg

                    if (!datas[index].summary.Image.empty)//摜H
                        g.DrawImage(datas[index].summary.Image.bitmap, 163, 70);//摜`

                    Font normalFont = new Font("lr o", 11, FontStyle.Bold);//ӂ̃tHg
                    g.DrawString(datas[index].summary.ScenarioExpression, normalFont, SolidBlack, 66, 181);//`
                    normalFont.Dispose();//ӂ̃tHg

                    Font smallFont = new Font("lr o", 9, FontStyle.Bold);//tHg
                    Rectangle rectCount = new Rectangle(0, 360, this.ClientSize.Width, smallFont.Height);//͈͂̐ݒ
                    g.DrawString((index + 1) + "/" + count, smallFont, SolidBlack, rectCount, format);//ViI̕`
                    smallFont.Dispose();//tHg                 

                    //AΏۃxǂOȂ
                    if ((datas[index].summary.LevelLow != 0) && (datas[index].summary.LevelHigh != 0))
                    {//\
                        Font levelFont = new Font("lr oSVbN", 11, FontStyle.Italic);//xptHg
                        Rectangle rectLevel = new Rectangle(0, 20, this.ClientSize.Width, levelFont.Height);//͈͂̐ݒ

                        string levelText;//Ώۃx̕
                        if (datas[index].summary.LevelLow == datas[index].summary.LevelHigh)//ΏۃxǂꏏȂ
                        {
                            levelText = "Ώۃx : " + datas[index].summary.LevelLow;//Œ჌x
                        }
                        else
                        {
                            levelText = "Ώۃx : " + datas[index].summary.LevelLow + " ` " + datas[index].summary.LevelHigh;//ʏ\
                        }

                        g.DrawString(levelText, levelFont, SolidBlue, rectLevel, format);//Ώۃx`
                        levelFont.Dispose();//xptHg
                    }

                    format.Dispose();//tH[}bg

                }
                else if (datas[index].contents != null)//contentsŃtH_
                {//tH_ł 
                    this.BtnSelect.Text = "";
                    bool abort = FilePath.CheckScenaFolder(datas[index].folder);
                    this.BtnCancel.Text = abort ? "~" : "߂";
                    
                    StringFormat format = new StringFormat();
                    format.Alignment = StringAlignment.Center;//

                    Font scenarioName = new Font(FontFamily.GenericMonospace, 20);//ViItHg
                    Rectangle rectScenarioName = new Rectangle(0, 36, this.ClientSize.Width, scenarioName.Height);//͈͂̐ݒ
                    g.DrawString(FilePath.FileNameFromPath(datas[index].folder), scenarioName, SolidBlack, rectScenarioName, format);//tH_
                    scenarioName.Dispose();//ViItHg

                    Font smallFont = new Font("lr o", 9, FontStyle.Bold);//tHg
                    Rectangle rectCount = new Rectangle(0, 360, this.ClientSize.Width, smallFont.Height);//͈͂̐ݒ                    
                    g.DrawString((index + 1) + "/" + count, smallFont, SolidBlack, rectCount, format);//ViI̕`
                    smallFont.Dispose();//tHg

                    format.Dispose();//tH[}bg

                }
                else if (datas[index].summaryReadError)//[hG[
                {
                }
                else//tH_݂Ȃ
                {
                }
            }
            ViewPanel.Invalidate();
        }

        protected override void doSelectPage()
        {//IƂ
            if (datas[index].summary != null)
            {//ViIł
                selectedData = datas[index];
                this.DialogResult = DialogResult.OK;
            }
            else if (datas[index].contents != null)
            {//tH_ł
                string folder = datas[index].folder;
                DirectoryInfo di = new DirectoryInfo(folder);
                List<ScenarioSelectData> lst = new List<ScenarioSelectData>();
                DirectoryInfo[] dis = di.GetDirectories();
                foreach (DirectoryInfo dii in dis)
                {
                    ScenarioSelectData ssd = new ScenarioSelectData();
                    ssd.folder = dii.FullName;
                    lst.Add(ssd);
                }
                datas = lst.ToArray();
                count = datas.Length;
                index = 0;
                ShowPage();
            }
        }

        protected override void doCancel()
        {
            bool abort = FilePath.CheckScenaFolder(datas[index].folder);
            if (abort)
            {
                base.doCancel();
            }
            else
            {
                string folder = datas[index].folder;
                DirectoryInfo di = new DirectoryInfo(Path.GetDirectoryName(folder));
                List<ScenarioSelectData> lst = new List<ScenarioSelectData>();
                DirectoryInfo[] dis = di.GetDirectories();
                foreach (DirectoryInfo dii in dis)
                {
                    ScenarioSelectData ssd = new ScenarioSelectData();
                    ssd.folder = dii.FullName;
                    lst.Add(ssd);
                }
                datas = lst.ToArray();
                count = datas.Length;
                index = 0;
                ShowPage();
            }
        }

    }//class

    public class ScenarioSelectData
    {//ViIf[^NX
        public string folder;//tH_H
        public SummaryData summary;
        public StringCollection contents;
        public bool summaryReadError = false;
    }

}