/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */

using System;
using CWIDatas;

namespace CWI
{
    /// <summary>
    /// Description of DiceRoll.
    /// </summary>
    public static class DiceRoll
    {
        #region 
        private static Random rnd = new Random(Convert.ToInt32(DateTime.Now.Ticks % Int32.MaxValue));

        /// <summary>
        /// 0ȏlimit̗̐Ԃ
        /// </summary>
        /// <param name="limit"></param>
        /// <returns></returns>
        public static int RandomInt(int limit)
        {
            return rnd.Next(limit);
        }

        /// <summary>
        /// 1D10
        /// </summary>
        /// <returns></returns>
        private static int Dice10()
        {
            return rnd.Next(1, 10);
        }

        /// <summary>
        /// 1D6
        /// </summary>
        /// <returns></returns>
        private static int Dice6()
        {
            return rnd.Next(1, 6);
        }

        #endregion

        #region \͔
        /// <summary>
        /// \͔Reg̔\͔
        /// </summary>
        /// <param name="target">肷LN^[</param>
        /// <param name="data">\͔Regf[^BAΏۂ̍ڂ͍lȂ</param>
        /// <returns>ɐtrue</returns>
        public static bool AbilityCheck(CharacterData target, AbilityCheckContent data)
        {
            if (data.SleeperFailer && target.IsSleep)
                return false;
            return AbilityCheck(target, data.Level, data.BodyFactor, data.MindFactor);
        }
        /// <summary>
        /// ʓIȔ\͔
        /// </summary>
        /// <param name="target">肷LN^[</param>
        /// <param name="level">背x</param>
        /// <param name="body">g̗vf</param>
        /// <param name="mind">萸_vf</param>
        /// <returns>ɐtrue</returns>
        public static bool AbilityCheck(CharacterData target, int level, g̓Ivf body, _Ivf mind)
        {
            int bonus = Util3.GetCharacterPower(target, body, mind);

            /*
             * āAxƐg̒lƐ_lƍs͏Cǂ
             * s炢̂
             */

            return false;//TODO
        }

        public static bool EscapeCheck(CharacterData target, int level)
        {
            //qƐTd̔肾ł̂ȁB
            //x͂̂܂܂ł̂H
            //U҂̔\͂͂ǂĊH
            return AbilityCheck(target, level, g̓Ivf.q, _Ivf.Td);
        }

        public static bool ResistCheck(CharacterData target, int level)
        {
            //qƐTd̔肾ł̂ȁB
            //x͂̂܂܂ł̂H
            //U҂̔\͂͂ǂĊH
            return AbilityCheck(target, level, g̓Ivf.q, _Ivf.Td);
        }

        #endregion

        #region ̑H
        /// <summary>
        /// ʒlۂɃ_CXUă_[W肷
        /// </summary>
        /// <param name="value">ʒl</param>
        /// <returns>_CXɂēꂽl</returns>
        public static int ClucDamage(int value)
        {
            int sum = 0;
            for (int d10 = value / 5; d10 > 0; d10--)
                sum += Dice10();
            sum += RandomInt(value % 5);

            return sum;
        }

        /// <summary>
        /// XLJ[hgp̐
        /// </summary>
        /// <param name="cardLevel">Z\J[h̃x</param>
        /// <param name="userLevel">gp҂̃x</param>
        /// <returns></returns>
        public static bool SkillUseCheck(uint cardLevel, uint userLevel)
        {
            return Two6DiceRoll((int)cardLevel - (int)userLevel - 1);
        }

        /// <summary>
        /// 퓬s߂邽߂ɃLN^[̔\͒lɉă_CXUďoԂB
        /// </summary>
        /// <param name="actor">_CXULN^[</param>
        /// <returns>_CX̖</returns>
        public static int ActOrderRoll(CharacterData actor)
        {
            int value = (int)actor.Level + (actor.MagicPowerBonus + actor.Agl - actor.Cautious) / 2;
            int sum = 0;
            for (int d10 = value / 5; d10 > 0; d10--)
                sum += Dice10();
            sum += RandomInt(value % 5);

            return sum;
        }

        /// <summary>
        /// Q̂Uʃ_CXUAvthresholdlȏȂ琬AȂ玸sB
        /// ÛڂoKB
        /// </summary>
        /// <param name="threshold">̂l</param>
        /// <returns>萬true</returns>
        private static bool Two6DiceRoll(int threshold)
        {
            int k = Dice6() + Dice6();
            if (k == 12)
                return true;
            return k >= threshold;
        }
        #endregion

    }//class


}
