using System;
using System.IO;
using CWIDatas;

namespace CWI
{
    public class IndexCharacterImage : DataWithIO
    {

        #region tB[h
        string characterName;
        ImageData image;
        #endregion

        #region vpeB
        public string Name
        {
            get { return characterName; }
            set { characterName = value; }
        }
        public ImageData Image
        {
            get { return image; }
            set { image = value; }
        }
        #endregion

        #region RXgN^

        public IndexCharacterImage(string file)
        {
            image = new ImageData();
            try
            {
                this.Read(file);
            }
            catch (Exception ex)
            {
                PartyMaker.CWIErrorMessage("ҋ@o[t@C̓ǂݍ݂ɎsF" + ex.Message);
            }
        }

        #endregion

        #region [hCg

        public override void Read(string file)
        {
            base.Read(file);
        }

        public override void Read(System.IO.BinaryReader r)
        {
            Stream stream = r.BaseStream;

            //nazo1_0
            int nazo1_0 = r.ReadInt16();

            if (nazo1_0 == 15)
            {
                r.BaseStream.Seek(2, SeekOrigin.Current);
                string versionString = ((SjisCBinaryReader)r).ReadBytesString(nazo1_0);
            } 
            characterName = r.ReadString();
            image.Read(r);

        }
        public override void Write(System.IO.BinaryWriter w)
        {
        }
        #endregion
    }
}
