/*
 * ̃\[ẌɊւĂReadmeQƂĂ
 *
 */
using System;
using System.Drawing;
using CWIDatas;
using CWI.Card;

namespace CWI
{

    /// <summary>
    /// xɑ΂鋭ƂAQ[oXɉe鐔lSʂƂ
    /// </summary>
    public static class GameParam
    {
        #region xƏLJ[h֘A
        /// <summary>
        /// levelx̃LN^[\ȃACeEZ\EbJ[h̍ő喇
        /// </summary>
        /// <param name="level">LN^[̃x</param>
        /// <param name="type">J[h̃^Cv</param>
        /// <returns>̍ől</returns>
        public static int GetMaxCardCount(uint level, WidIDtype type)
        {
            switch (type)
            {
                case WidIDtype.ACe:
                case WidIDtype.XL:
                    return (int)Math.Ceiling(level / 2.0) + 2;
                case WidIDtype.b:
                    return (int)Math.Ceiling((level + 2) / 4.0);
                default:
                    return 0;
            }
        }

        /// <summary>
        /// charaLevelx̃LN^[cardLevelx̋Z\J[hgő
        /// </summary>
        /// <param name="charaLevel">LN^[̃x</param>
        /// <param name="cardLevel">Z\J[h̃x</param>
        /// <returns>gp񐔂̍ől</returns>
        public static uint GetMaxSkillUseCount(uint charaLevel, uint cardLevel)
        {
            int l = (int)charaLevel - (int)cardLevel;
            if (l >= 3)
                return 9;
            else if (l == 2)
                return 8;
            else if (l == 1)
                return 7;
            else if (l == 0)
                return 5;
            else if (l == -1)
                return 3;
            else if (l == -2)
                return 2;
            else
                return 1;
        }

        /// <summary>
        /// levelx̃LN^[gpɎs\̂XLJ[hx̍Œl
        /// </summary>
        /// <param name="level">gpLN^[x</param>
        /// <returns>sXLx̍Œl</returns>
        public static uint GetOverLevelSkillLimit(uint level)
        {
            return level + 4;
        }

        /// <summary>
        /// levelx̃LN^[̐퓬D̖
        /// </summary>
        /// <param name="level">LN^[̃x</param>
        /// <returns>D̐</returns>
        public static int GetBattleCardCount(uint level)
        {
            return (int)Math.Ceiling(level / 2.0) + 4;
        }

        /// <summary>
        /// K̗΁̒iKԂBTiK
        /// </summary>
        /// <param name="cd">p[^oLN^[</param>
        /// <param name="body">g̓Ivf</param>
        /// <param name="mind">_Ivf</param>
        /// <returns>O`SBOŒ</returns>
        public static int GetCardFacterColor(CharacterData cd, g̓Ivf body, _Ivf mind)
        {
            return GetCardFacterColor(cd,
                                      body,
                                      mind,
                                      0);

        }

        /// <summary>
        /// K̗΁̒iKԂBTiK
        /// </summary>
        /// <param name="cd">p[^oLN^[</param>
        /// <param name="body">g̓Ivf</param>
        /// <param name="mind">_Ivf</param>
        /// <param name="bless">s͏C</param>
        /// <returns>O`SBOŒ</returns>
        public static int GetCardFacterColor(CharacterData cd,
                                             g̓Ivf body,
                                             _Ivf mind,
                                             int bless)
        {
            int val = Util3.GetCharacterPower(cd, body, mind, bless);
            if (val < 3)
                return 0;
            else if (val < 9)
                return 1;
            else if (val < 15)
                return 2;
            else if (val < 20)
                return 3;
            else
                return 4;

        }

        /// <summary>
        /// Z\c񐔂̐ԁ̒iKԂBTiK
        /// </summary>
        /// <param name="current"></param>
        /// <param name="max"></param>
        /// <returns>O`SBOcOASc肪Max</returns>
        public static int GetSkillRemainColor(uint current, uint max)
        {
            if (current >= max)
                return 4;
            if (current > (max / 2.0))
                return 3;
            if (current > 1)
                return 2;
            if (current == 1)
                return 1;
            return 0;
        }
        #endregion

        #region 퓬D֌W

        private static readonly int ActionCardSum = 100;
        private static readonly int rateAtack = 40;
        private static readonly int rateBigAtack = 15;
        private static readonly int rateEvate = 15;
        private static readonly int rateGuard = 15;
        private static readonly int rateFeint = 10;
        private static readonly int rateSlash = 5;

        public enum BattleCardKind : byte
        { D, U, Ӑg̈ꌂ, S̈ꌂ, tFCg, h, ؂, , , Z\J[h }

        private static readonly BattleCardKind[] actionCardTable;

        /// <summary>
        /// Z\̎gpc񐔂lāADɉZ\J[hIB
        /// SĂ̎gp񐔂sĂnullԂB
        /// I΂ꂽXLJ[h͎gp񐔂P炳B
        /// </summary>
        /// <param name="chara">J[hILN^[</param>
        /// <returns>I΂ꂽZ\J[h̎Q</returns>
        private static WidCard SelectSkillCard(CharacterData chara)
        {
            //c񐔍vJEg
            uint sum = 0;
            foreach (WidCard skill in chara.Skills)
            {
                sum += skill.SkillRemainUseCount;
            }
            //SĐsĂΎs
            if (sum == 0)
                return null;
            //zzJ[ȟ
            int r = DiceRoll.RandomInt((int)sum);
            sum = 0;
            foreach (WidCard skill in chara.Skills)
            {
                sum += skill.SkillRemainUseCount;
                if (r < sum) //rsum̐Ȃ̂ŕK̏͂ꐬ
                {
                    skill.SkillRemainUseCount -= 1;
                    return skill;
                }
            }
            return null;
        }

        /// <summary>
        /// kŎw肵ANVJ[hWidCardIuWFNgԂB
        /// iIuWFNg͗BɂύX֎~j
        /// </summary>
        /// <param name="kind">ANVJ[h̎</param>
        /// <returns>WidCardIuWFNg</returns>
        public static WidCard GetActionWid(BattleCardKind kind)
        {
            switch (kind)
            {
                case BattleCardKind.D:
                    return ActionCardChangeCards;
                case BattleCardKind.U:
                    return ActionCardAttack;
                case BattleCardKind.Ӑg̈ꌂ:
                    return ActionCardBigAttack;
                case BattleCardKind.S̈ꌂ:
                    return ActionCardSlash;
                case BattleCardKind.tFCg:
                    return ActionCardFeint;
                case BattleCardKind.h:
                    return ActionCardGuard;
                case BattleCardKind.؂:
                    return ActionCardEvade;
                case BattleCardKind.:
                    return ActionCardConfuse;
                case BattleCardKind.:
                    return ActionCardEscape;
                default:
                    return ActionCardAttack;//Ƃ肠UԂƂ
            }
        }

        #endregion

        #region ANVJ[h`
        public static WidCard ActionCardChangeCards;
        public static WidCard ActionCardAttack;
        public static WidCard ActionCardBigAttack;
        public static WidCard ActionCardSlash;
        public static WidCard ActionCardFeint;
        public static WidCard ActionCardGuard;
        public static WidCard ActionCardEvade;
        public static WidCard ActionCardConfuse;
        public static WidCard ActionCardEscape;

        
        static GameParam()
        {
            #region ANVJ[hzze[u
            actionCardTable = new BattleCardKind[ActionCardSum];
            //G[`FbN
            int temp = rateAtack + rateBigAtack + rateEvate + rateGuard + rateFeint + rateSlash;
            if (temp != ActionCardSum)
            {
                //lݒG[
                temp = -1;
                actionCardTable[temp] = BattleCardKind.U;
                //s׍HǂƂ肠G[oĎʂ낤
            }
            int idx = 0;
            for (int i = 0; i < rateAtack; i++)
                actionCardTable[idx++] = BattleCardKind.U;
            for (int i = 0; i < rateBigAtack; i++)
                actionCardTable[idx++] = BattleCardKind.Ӑg̈ꌂ;
            for (int i = 0; i < rateEvate; i++)
                actionCardTable[idx++] = BattleCardKind.؂;
            for (int i = 0; i < rateGuard; i++)
                actionCardTable[idx++] = BattleCardKind.h;
            for (int i = 0; i < rateFeint; i++)
                actionCardTable[idx++] = BattleCardKind.tFCg;
            for (int i = 0; i < rateSlash; i++)
                actionCardTable[idx++] = BattleCardKind.S̈ꌂ;
            
            #endregion

            
            EffectData effect = null;

            #region D
            WidCard actWid;
            ActionCardChangeCards = new WidCard(WidIDtype.ANV);
            actWid = ActionCardChangeCards;
            actWid.CardName = "J[h";
            actWid.Expression = "퓬sJ[hijBACeJ[hSẴJ[ĥĂāAVJ[hɌB";
            actWid.BodyFacter = g̓Ivf.m;
            actWid.MindFacter = _Ivf.Td;
            actWid.EffectAttribute = ʑ.;
            actWid.ResistAttribute = R.K;
            actWid.Target = ʖڕW.gp;
            actWid.Range = ʔ͈.P;
            effect = new EffectData();
            effect.Version = 5;
            effect.EffectTab = EffectData.ʃ^u.;
            effect.EffectNumberInTab = 1;//ł̂P̓J[h
            effect.Attribute = EffectData..S;
            actWid.Effects.Add(effect);
            actWid.Image = new ImageData(CWIEngine.Properties.Resources.Card_J[h);
            actWid.Image.bitmap.MakeTransparent(actWid.Image.bitmap.GetPixel(0, 0));
            actWid.SoundOnEffect = "gpi@j.wav";
            actWid.UsingSound = "ʁit^j.wav";
            actWid.Version = 5;
            actWid.VisualEffect = o.];
            #endregion
            #region U
            ActionCardAttack = new WidCard(WidIDtype.ANV);
            actWid = ActionCardAttack;
            actWid.CardName = "U";
            actWid.Expression = "퓬sJ[hiUjBĜɑ΂ĕɂUsBłzz̍퓬̊{ƂȂJ[hłB̍sɂ͋ؗ͂ƗE҂vBԂȂڕWɂ͌ʂ𔭊ȂB";
            actWid.BodyFacter = g̓Ivf.ؗ;
            actWid.MindFacter = _Ivf.EҐ;
            actWid.EffectAttribute = ʑ.;
            actWid.ResistAttribute = R.𑮐;
            actWid.Target = ʖڕW.G;
            actWid.Range = ʔ͈.P;
            effect = new EffectData();
            effect.Version = 5;
            effect.EffectTab = EffectData.ʃ^u.;
            effect.EffectNumberInTab = 1;//͂̂P̓_[W
            effect.Attribute = EffectData..S;
            effect.ValueKind = EffectData.l̎.x;
            effect.Value = 2;
            actWid.Effects.Add(effect);
            actWid.Image = new ImageData(CWIEngine.Properties.Resources.Card_U);
            actWid.Image.bitmap.MakeTransparent(actWid.Image.bitmap.GetPixel(0, 0));
            actWid.KeyCode[0] = "U";
            actWid.UsingSound = "fUiUj.wav";
            actWid.SoundOnEffect = "ʁiUj.wav";
            actWid.Version = 5;
            actWid.VisualEffect = o.U;
            #endregion
            #region Ӑg̈ꌂ
            ActionCardBigAttack = new WidCard(WidIDtype.ANV);
            actWid = ActionCardBigAttack;
            actWid.CardName = "Ӑg̈ꌂ";
            actWid.Expression = "퓬sJ[hiUjBSgS߂ꌂĜɂԂBڕWɗ^Q͋ɂ߂đ傫AƂ_BɂÛ߁AԂȂڕWɂ͌ʂȂB̎gpɂ͋ؗ͂ƓSKvƂB";
            actWid.BodyFacter = g̓Ivf.ؗ;
            actWid.MindFacter = _Ivf.D퐫;
            actWid.EffectAttribute = ʑ.;
            actWid.ResistAttribute = R.𑮐;
            actWid.Target = ʖڕW.G;
            actWid.Range = ʔ͈.P;
            actWid.SuccessRate = -2;
            effect = new EffectData();
            effect.Version = 5;
            effect.EffectTab = EffectData.ʃ^u.;
            effect.EffectNumberInTab = 1;//͂̂P̓_[W
            effect.Attribute = EffectData..S;
            effect.ValueKind = EffectData.l̎.x;
            effect.Value = 4;
            actWid.Effects.Add(effect);
            actWid.Image = new ImageData(CWIEngine.Properties.Resources.Card_Ӑg̈ꌂ);
            actWid.Image.bitmap.MakeTransparent(actWid.Image.bitmap.GetPixel(0, 0));
            actWid.KeyCode[0] = "U";
            actWid.UsingSound = "fUiӐgj.wav";
            actWid.SoundOnEffect = "ʁiӐgj.wav";
            actWid.Version = 5;
            actWid.VisualEffect = o.U;
            #endregion
            #region S̈ꌂ
            ActionCardSlash = new WidCard(WidIDtype.ANV);
            actWid = ActionCardSlash;
            actWid.CardName = "S̈ꌂ";
            actWid.Expression = "퓬sJ[hiUjBĜɋ}˂vIȈꌂBA_[WƂɍAx̓Gɑ΂ėLłB̎gpɂ͊pƗE҂KvƂBԂ̂ȂڕWɂ͌ʂ𔭊ȂB";
            actWid.BodyFacter = g̓Ivf.px;
            actWid.MindFacter = _Ivf.EҐ;
            actWid.EffectAttribute = ʑ.;
            actWid.ResistAttribute = R.𑮐;
            actWid.Target = ʖڕW.G;
            actWid.Range = ʔ͈.P;
            actWid.SuccessRate = 2;
            effect = new EffectData();
            effect.Version = 5;
            effect.EffectTab = EffectData.ʃ^u.;
            effect.EffectNumberInTab = 1;//͂̂P̓_[W
            effect.Attribute = EffectData..S;
            effect.ValueKind = EffectData.l̎.x;
            effect.Value = 3;
            actWid.Effects.Add(effect);
            actWid.Image = new ImageData(CWIEngine.Properties.Resources.Card_S̈ꌂ);
            actWid.Image.bitmap.MakeTransparent(actWid.Image.bitmap.GetPixel(0, 0));
            actWid.KeyCode[0] = "U";
            actWid.UsingSound = "fUiSj.wav";
            actWid.SoundOnEffect = "ʁiSj.wav";
            actWid.Version = 5;
            actWid.VisualEffect = o.U;
            #endregion
            #region tFCg
            ActionCardFeint = new WidCard(WidIDtype.ANV);
            actWid = ActionCardFeint;
            actWid.CardName = "tFCg";
            actWid.Expression = "퓬sJ[hiUjBĜɑ΂A𐶂ݏoUUd|BIȔQ^鎖͂ȂAڕW͓hs̎RDBgpɂ͊pςvBȐ_ڕWɂʂȂB";
            actWid.BodyFacter = g̓Ivf.px;
            actWid.MindFacter = _Ivf.ϐ;
            actWid.EffectAttribute = ʑ.;
            actWid.ResistAttribute = R.𑮐;
            actWid.Target = ʖڕW.G;
            actWid.Range = ʔ͈.P;
            actWid.SuccessRate = 2;
            effect = new EffectData();
            effect.Version = 5;
            effect.EffectTab = EffectData.ʃ^u.J[h;
            effect.EffectNumberInTab = 6;//J[h6͍zz
            effect.Attribute = EffectData.._;
            actWid.Effects.Add(effect);
            actWid.Image = new ImageData(CWIEngine.Properties.Resources.Card_tFCg);
            actWid.Image.bitmap.MakeTransparent(actWid.Image.bitmap.GetPixel(0, 0));
            actWid.KeyCode[0] = "U";
            actWid.KeyCode[1] = "h";
            actWid.UsingSound = "fUiSj.wav";
            actWid.SoundOnEffect = "ʁij.wav";
            actWid.Version = 5;
            actWid.VisualEffect = o.nk;
            #endregion
            #region h
            ActionCardGuard = new WidCard(WidIDtype.ANV);
            actWid = ActionCardGuard;
            actWid.CardName = "h";
            actWid.Expression = "퓬sJ[hihjBG̍Uɑ΂ł߂B̃J[hIEh́Ah͂Ɩ@ɑ΂R͂シB";
            actWid.BodyFacter = g̓Ivf._;
            actWid.MindFacter = _Ivf.Td;
            actWid.EffectAttribute = ʑ.;
            actWid.ResistAttribute = R.𑮐;
            actWid.Target = ʖڕW.Ώۖ;
            actWid.Range = ʔ͈.P;
            actWid.ResistModifyUsing = 5;
            actWid.ArmorModifyUsing = 5;
            actWid.Image = new ImageData(CWIEngine.Properties.Resources.Card_h);
            actWid.Image.bitmap.MakeTransparent(actWid.Image.bitmap.GetPixel(0, 0));
            actWid.KeyCode[0] = "h";
            actWid.UsingSound = "VXeE.wav";
            actWid.SoundOnEffect = "";
            actWid.Version = 5;
            #endregion
            #region ؂
            ActionCardEvade = new WidCard(WidIDtype.ANV);
            actWid = ActionCardEvade;
            actWid.CardName = "؂";
            actWid.Expression = "퓬sJ[hihjBG̍U؂AdŉB̃J[hIĂ郉Eh́AɂUɑ΂𗦂シB";
            actWid.BodyFacter = g̓Ivf.q;
            actWid.MindFacter = _Ivf.Td;
            actWid.EffectAttribute = ʑ.;
            actWid.ResistAttribute = R.𑮐;
            actWid.Target = ʖڕW.Ώۖ;
            actWid.Range = ʔ͈.P;
            actWid.AvoidModifyUsing = 5;
            actWid.Image = new ImageData(CWIEngine.Properties.Resources.Card_؂);
            actWid.Image.bitmap.MakeTransparent(actWid.Image.bitmap.GetPixel(0, 0));
            actWid.KeyCode[0] = "h";
            actWid.UsingSound = "VXeE.wav";
            actWid.SoundOnEffect = "";
            actWid.Version = 5;
            #endregion
            #region 
            ActionCardConfuse = new WidCard(WidIDtype.ANV);
            actWid = ActionCardConfuse;
            actWid.CardName = "";
            actWid.Expression = "퓬sJ[hijB@tFCg󂯂ēl҂ɔzzyieBJ[hB̃J[hIEg͉ARɃyieB^B";
            actWid.BodyFacter = g̓Ivf.m;
            actWid.MindFacter = _Ivf.Td;
            actWid.EffectAttribute = ʑ.;
            actWid.ResistAttribute = R.𑮐;
            actWid.Target = ʖڕW.Ώۖ;
            actWid.Range = ʔ͈.P;
            actWid.ArmorModifyUsing = -10;
            actWid.AvoidModifyUsing = -10;
            actWid.ResistModifyUsing = -10;
            actWid.Image = new ImageData(CWIEngine.Properties.Resources.Card_);
            actWid.Image.bitmap.MakeTransparent(actWid.Image.bitmap.GetPixel(0, 0));
            actWid.KeyCode[0] = "yieB";
            actWid.UsingSound = "ʁij.wav";
            actWid.SoundOnEffect = "";
            actWid.Version = 5;
            #endregion
            #region 
            ActionCardEscape = new WidCard(WidIDtype.ANV);
            actWid = ActionCardEscape;
            actWid.CardName = "";
            actWid.Expression = "퓬sJ[hijB";
            actWid.BodyFacter = g̓Ivf.m;
            actWid.MindFacter = _Ivf.a;
            actWid.EffectAttribute = ʑ.;
            actWid.ResistAttribute = R.𑮐;
            actWid.Target = ʖڕW.Ώۖ;
            actWid.Range = ʔ͈.P;
            actWid.Image = new ImageData(CWIEngine.Properties.Resources.Card_S);
            actWid.Image.bitmap.MakeTransparent(actWid.Image.bitmap.GetPixel(0, 0));
            actWid.KeyCode[0] = "";
            actWid.UsingSound = "VXeE.wav";
            actWid.SoundOnEffect = "";
            actWid.Version = 5;
            #endregion
            
        }
        #endregion

    }//class
}
