
using System;
using System.Collections.Generic;
using System.IO;
using CWIDatas;
using System.Drawing;

namespace CWI
{
    public static class Util2
    {
        #region wi֘A

        /// <summary>
        /// list̃ZtOĕ\邩ǂXVB
        /// For PartyMaker
        /// </summary>
        /// <param name="list">XVZ̃Xg</param>
        public static void UpdateCells(ScenarioData scenario)
        {
            foreach (CellData cl in scenario.Cells)
            {
                if (cl.FlagName == "")
                    cl.Visible = true;
                else
                {
                    bool isVisible = false;
                    foreach (string val in scenario.FlagValues)
                    {
                        if (val.StartsWith(cl.FlagName))
                        {
                            isVisible = (Util1.ValueOfStrings(val) == "1");
                            break;
                        }
                    }

                    cl.Visible = isVisible;
                }
            }
        }

        /// <summary>
        /// p̊ۂ``
        /// </summary>
        /// <param name="g"></param>
        /// <param name="rect"></param>
        /// <param name="arcWidth"></param>
        /// <param name="arcHeight"></param>
        public static void DrawRoundRect2D(Graphics g,Pen pen, Rectangle rect, int arcWidth, int arcHeight)
        {
            g.DrawLine(pen, rect.X + arcWidth, rect.Y, rect.X + rect.Width - arcWidth, rect.Y);
            g.DrawLine(pen, rect.X + arcWidth, rect.Y + rect.Height, rect.X + rect.Width - arcWidth, rect.Y + rect.Height);
            g.DrawLine(pen, rect.X, rect.Y + arcHeight, rect.X, rect.Y + rect.Height - arcHeight);
            g.DrawLine(pen, rect.X + rect.Width, rect.Y + arcHeight, rect.X + rect.Width, rect.Y + rect.Height - arcHeight);
            Size size = new Size(arcWidth * 2,arcHeight * 2);
            g.DrawArc(pen, new Rectangle(rect.Location, size), 180.0F, 90.0F);
            g.DrawArc(pen, new Rectangle(new Point(rect.X + rect.Width - arcWidth * 2, rect.Y), size), 270.0F, 90.0F);
            g.DrawArc(pen, new Rectangle(new Point(rect.X, rect.Y + rect.Height - arcHeight * 2), size), 90.0F, 90.0F);
            g.DrawArc(pen, new Rectangle(new Point(rect.X + rect.Width - arcWidth * 2, rect.Y + rect.Height - arcHeight * 2), size), 0.0F, 90.0F);

        }

        #endregion

        #region ו܂Ƌɂ̃J[ho
        /// <summary>
        /// ו܂ƏhɂɎgRenamedCardDataIuWFNgnewĕԂB
        /// J[hǉAddRenamedCardDatagBpublic͋֎~B
        /// </summary>
        /// <param name="useCount">cgp񐔁iACeȊOӖj</param>
        /// <param name="renamed">ۂɕۑt@C</param>
        /// <returns>VRenamedCardDataIuWFNg</returns>
        private static RenamedCardData newRenamedCardData(uint useCount, string renamed)
        {
            RenamedCardData renamedCard = new RenamedCardData();
            renamedCard.UseCount = useCount;
            renamedCard.RenamedName = renamed;
            renamedCard.FixPossession = false;
            return renamedCard;
        }

        #endregion

        #region LN^[̎DJ[h

        /// <summary>
        /// widIDŎꂽwidJ[hnIDɑ΂āAoneĂ閇ԂB
        /// </summary>
        /// <param name="one"></param>
        /// <param name="widID">ACeXLbwidID</param>
        /// <returns>ĂJ[h̖BIDs̏ꍇOԂB</returns>
        public static int GetCharactersCardCount(CharacterData one, WidIDtype widID)
        {
            switch (widID)
            {
                case WidIDtype.ACe:
                    return one.Items.Count;
                case WidIDtype.XL:
                    return one.Skills.Count;
                case WidIDtype.b:
                    return one.Beasts.Count;
                default:
                    return 0;
            }
        }

        /// <summary>
        /// LN^[cardƈvJ[hꖇ폜
        /// </summary>
        /// <param name="character">폜ƂȂLN^[</param>
        /// <param name="card">f[^ƂȂwidJ[h</param>
        /// <returns>폜łtrue</returns>
        public static bool DeleteWidCard(CharacterData character, WidCard card)
        {
            switch (card.WidID)
            {
                case WidIDtype.ACe:
                    foreach (WidCard wc in character.Items)
                    {
                        if (wc.CardName == card.CardName &&
                            wc.Expression == card.Expression)
                        {
                            character.Items.Remove(wc);
                            return true;
                        }
                    }
                    break;
                case WidIDtype.XL:
                    foreach (WidCard wc in character.Skills)
                    {
                        if (wc.CardName == card.CardName &&
                            wc.Expression == card.Expression)
                        {
                            character.Skills.Remove(wc);
                            return true;
                        }
                    }
                    break;
                case WidIDtype.b:
                    foreach (WidCard wc in character.Beasts)
                    {
                        if (wc.CardName == card.CardName &&
                            wc.Expression == card.Expression)
                        {
                            character.Beasts.Remove(wc);
                            return true;
                        }
                    }
                    break;
            }
            return false;
        }

        /// <summary>
        /// charactercardɈvJ[hĂ閇Ԃ
        /// </summary>
        /// <param name="character">ׂLN^[</param>
        /// <param name="card">v𒲂ׂJ[h</param>
        /// <returns>Ă</returns>
        public static int CountWidCard(CharacterData character, WidCard card)
        {
            int ret = 0;
            switch (card.WidID)
            {
                case WidIDtype.ACe:
                    foreach (WidCard wc in character.Items)
                    {
                        if (wc.CardName == card.CardName &&
                            wc.Expression == card.Expression)
                        {
                            ret++;
                        }
                    }
                    return ret;
                case WidIDtype.XL:
                    foreach (WidCard wc in character.Skills)
                    {
                        if (wc.CardName == card.CardName &&
                            wc.Expression == card.Expression)
                        {
                            ret++;
                        }
                    }
                    return ret;
                case WidIDtype.b:
                    foreach (WidCard wc in character.Beasts)
                    {
                        if (wc.CardName == card.CardName &&
                            wc.Expression == card.Expression)
                        {
                            ret++;
                        }
                    }
                    return ret;
            }
            return ret;
        }

        /// <summary>
        /// L[R[huyieBv
        /// </summary>
        /// <param name="wc"></param>
        /// <returns></returns>
        public static bool IsPenaltyCard(WidCard wc)
        {
            foreach (string s in wc.KeyCode)
                if (s == "yieB")
                    return true;
            return false;
        }

        /// <summary>
        /// L[R[huTCNv
        /// </summary>
        /// <param name="wc"></param>
        /// <returns></returns>
        public static bool IsRecycleCard(WidCard wc)
        {
            foreach (string s in wc.KeyCode)
                if (s == "TCN")
                    return true;
            return false;
        }
        #endregion

    }


}
